/**
 * Created with JetBrains WebStorm.
 * User: aravind
 * Date: 14/8/13
 * Time: 9:08 AM
 * To change this template use File | Settings | File Templates.
 */

define(function () {
    return function fVMblog() {
        var self = this;

        //Data
        self.blogFeed = ko.observableArray([]);
        self.blogFeedUpdatedAt = ko.observable('No updates yet');


        // Boolean
        self.pullToRefreshBlog = ko.observable(false);


        // This is if some actions need to be completed before play page is shown
        self.buildBlogPage = function () {
            fg.fVM.setHeaderTitle('Blog');

            self.loadBlogFeed();

            fg.fVM.showPage('fid-blogPage', 'fc-pageAppear');
            fg.actionComplete(fg.waitFor.load_page+"#blog");
        };

        self.loadBlogFeed = function() {
            if (fg.fVM.online()) {
                fg.actionStarted(fg.waitFor.loading_blog_feed);
                fg.rssFeed( fg.blogUrl, {ssl:false}, fg.fVM.bindBlogFeed );
                fg.stillLoadingBlogFeed = true;
            }
            else {
                var blogFeed = fg.fantainStore.get('blogFeed');
                if (blogFeed != null && blogFeed.entries.length > 0) {
                    fg.actionStarted(fg.waitFor.loading_blog_feed);
                    fg.fVM.blogFeedUpdatedAt(fg.fantainStore.get('blogFeedUpdatedAt'));
                    fg.fVM.bindBlogFeed('stored', blogFeed);
                } else {
                    fg.fantainMsgOkCallback = '';
                    fg.fantainMsg('Looks like the connection is down, try later!', fg.fantainMsgType.alert);
                }
            }
        }

        self.bindBlogFeed = function (status, feed) {
            if (status == 'error') {
                fg.actionComplete(fg.waitFor.loading_blog_feed);
                fg.fantainMsgOkCallback = $.noop;
                fg.fantainMsg('Some error occurred getting blogs, try again later', fg.fantainMsgType.confirm);
            } else {

                var noOfPrevBlogFeedItems = fg.fVM.blogFeed().length;
                self.blogFeed.removeAll();

                var blogentry, blogexit;
                for (var i = 0; i < feed.entries.length; i++ ) {
                    blogentry = feed.entries[i];
                    blogexit = {};
                    blogexit.title = blogentry.title;
                    blogexit.publishedDate = fg.dates.formatDate(blogentry.publishedDate,'w, dd mmmm hh:mi 12');
                    blogexit.link = 'fid-bloglink-'+blogentry.link;
                    blogexit.image = [];

                    //Handle the image tags
                    var x = fg.removeImg(blogentry.content);
                    blogentry.content = x[0];
                    blogexit.image = x.slice(1);

                    //Now handle the hyperlinks
                    blogexit.content = fg.replaceHref(blogentry.content, 'fid-bloglink-');

                    fg.fVM.blogFeed.push(blogexit);
                }

                // list item fade in
                //fg.fVM.listItemFadeIn('.fc-blog-list-item');

                if(fg.fVM.blogFeed().length > noOfPrevBlogFeedItems && noOfPrevBlogFeedItems > 0) {
                    fg.cb.inAppNotification( 'NewBlog', 'New blog entries added', 'New Blog' );
                }


                if (status != 'stored') {
                    //First store it locally so it can be retrieved when connection is down
                    fg.actionStarted(fg.waitFor.local_store + 'blogs');
                    fg.fantainStore.clear('blogFeed');
                    fg.fantainStore.set('blogFeed', feed);
                    fg.fVM.blogFeedUpdatedAt(fg.dates.formatDate(new Date, 'dd-mmmm at hh:mi 12'));
                    fg.fantainStore.set('blogFeedUpdatedAt', fg.fVM.blogFeedUpdatedAt() );
                    fg.actionComplete(fg.waitFor.local_store + 'blogs');
                }

                fg.actionComplete(fg.waitFor.loading_blog_feed);
                fg.stillLoadingBlogFeed = false;
                if(!fg.loadingBlogFeed) {
                    self.pullToRefreshBlog(false);
                }

            }
        };

    }
});
