/**
 * Created with JetBrains WebStorm.
 * User: aravind
 * Date: 14/8/13
 * Time: 9:08 AM
 * To change this template use File | Settings | File Templates.
 */

define(function () {
    return function fVMfanzone() {
        var self = this;

        //Data
        self.FBFeed = ko.observableArray([]);
        self.FBFeedUpdatedAt = ko.observable('No updates yet');

        // Boolean
        self.pullToRefreshFacebook = ko.observable(false);


        // This is if some actions need to be completed before play page is shown
        self.buildFanzonePage = function () {
            fg.fVM.setHeaderTitle('Fanzone');

            self.loadFacebookFeed();

            fg.fVM.showPage('fid-fanzonePage', 'flipInY');
            fg.actionComplete(fg.waitFor.load_page+"#fanzone");

        };

        self.loadFacebookFeed = function() {
            if (fg.fVM.online()) {
                fg.actionStarted(fg.waitFor.loading_fb_feed);
                fg.rssFeed( fg.fanzoneUrl, {ssl:true}, fg.fVM.bindFBFeed );
                fg.stillLoadingFacebookFeed = true;
            }
            else {
                var FBFeed = fg.fantainStore.get('FBFeed');
                if (FBFeed != null && FBFeed.entries.length > 0) {
                    fg.actionStarted(fg.waitFor.loading_fb_feed);
                    fg.fVM.FBFeedUpdatedAt(fg.fantainStore.get('FBFeedUpdatedAt'));
                    fg.fVM.bindFBFeed('stored', FBFeed);
                } else {
                    fg.fantainMsgOkCallback = '';
                    fg.fantainMsg('Looks like the connection is down, try later!', fg.fantainMsgType.alert);
                }
            }
        }

        self.bindFBFeed = function (status, feed) {
            if (status == 'error') {
                fg.actionComplete(fg.waitFor.loading_fb_feed);
                fg.fantainMsgOkCallback = $.noop;
                fg.fantainMsg('Some error occurred getting FB feeds, try again later', fg.fantainMsgType.confirm);
            } else {

                var noOfPrevFacebookItems = fg.fVM.FBFeed().length;
                self.FBFeed.removeAll();

                var fbentry, fbexit;
                for (var i = 0; i < feed.entries.length; i++ ) {
                    fbentry = feed.entries[i];
                    fbexit = {};
                    fbexit.title = fbentry.title;
                    fbexit.publishedDate = fg.dates.formatDate(fbentry.publishedDate,'w, dd mmmm hh:mi 12');
                    fbexit.link = 'fid-fblink-'+fbentry.link;
                    fbexit.image = [];

                    //Handle the image tags
                    var x = fg.removeImg(fbentry.content);
                    fbentry.content = x[0];
                    fbexit.image = x.slice(1);


                    //For FB, handle safe images
                    for (var j=0 ; j < fbexit.image.length; j++ ) {
                        fbexit.image[j] = unescape(fbexit.image[j]).replace(/https:\/\/fbexternal-a\.akamaihd\.net\/safe_image\.php\?.*?url=/,'');
                    }

                    //Now handle the hyperlinks
                    fbexit.content = fg.replaceHref(fbentry.content, 'fid-fblink-');

                    //For FB, handle relative hyperlinks
                    fbexit.content = fbexit.content.replace(/fid-fblink-\//gi,'fid-fblink-http://www.facebook.com/');

                    fg.fVM.FBFeed.push(fbexit);

                }

                // list item fade in
                //fg.fVM.listItemFadeIn('.fc-facebook-list-item');

                if(fg.fVM.FBFeed().length > noOfPrevFacebookItems && noOfPrevFacebookItems > 0) {
                    fg.cb.inAppNotification( 'NewsFacebookPost', 'New Facebook posts added', 'New facebook post' );
                }


                if (status != 'stored') {
                    //First store it locally so it can be retrieved when connection is down
                    fg.actionStarted(fg.waitFor.local_store + 'facebook');
                    fg.fantainStore.clear('FBFeed');
                    fg.fantainStore.set('FBFeed', feed);
                    fg.fVM.FBFeedUpdatedAt(fg.dates.formatDate(new Date, 'dd-mmmm at hh:mi 12'));
                    fg.fantainStore.set('FBFeedUpdatedAt', fg.fVM.FBFeedUpdatedAt() );
                    fg.actionComplete(fg.waitFor.local_store + 'facebook');
                }

                fg.actionComplete(fg.waitFor.loading_fb_feed);
                fg.stillLoadingFacebookFeed = false;
                if(!fg.loadingFacebookFeed) {
                    self.pullToRefreshFacebook(false);
                }

            }
        };

    }
});
