/**
 * Created with JetBrains WebStorm. User: aravind Date: 14/8/13 Time: 5:36 PM To
 * change this template use File | Settings | File Templates.
 */

define([ 'fVMglobal', 'fVMheader', 'fVMfooter', 'fVMhome', 'fVMlaunch',
		'fVMplay', 'fVMschedule', 'fVMlogin', 'fVMprofile', 'fVMleaderboard',
		'fVMschedule', 'fVMscores', 'fVMconnect', 'fVMshop', 'fVMabout', 'fVMblog',
		'fVMnews', 'fVMfanzone','fVMfollow', 'fVMconsole', 'fVMchoosefriends' ], function(fVMglobal,
		fVMheader, fVMfooter, fVMhome, fVMlaunch, fVMplay, fVMschedule, fVMlogin,
		fVMprofile, fVMleaderboard, fVMschedule, fVMscores, fVMconnect,
		fVMshop, fVMabout, fVMblog, fVMnews, fVMfanzone, fVMfollow,  fVMconsole, fVMchoosefriends) {
	return function fantainViewModel() {
		var self = this;

		var tObj;
		$.each([ fVMglobal, fVMheader, fVMfooter, fVMhome, fVMlaunch, fVMplay,
				fVMschedule, fVMlogin, fVMprofile, fVMleaderboard, fVMschedule,
				fVMscores, fVMconnect, fVMshop, fVMabout, fVMblog, fVMnews, fVMfanzone, fVMfollow, fVMconsole,
                fVMchoosefriends ], function(key, value) {
			tObj = new value();
			for ( var p in tObj)
				self[p] = tObj[p];
		});

		// Yoohoo!!! Put all cross sectional dependencies here

		self.leaderboardUrl = ko.computed(function() {
			var url = 'leaderboard/';
			return (self.currentLB() == self.currentMatchText() && self.matchInfo() != null &&
					self.gameOn()) ? url + self.matchInfo().id().toString() : url;
		});

        self.lbFriendsToSend = ko.computed(function() {
            var temp = {'id' : []};
            if (self.currentLBFor() == self.lbMyFriendsText())
                if (self.gameOn()) {
                    for ( var i = 0; i < self.playcallFriends().length; i++)
                        if (self.playcallFriends()[i].chosenFriend())
                            temp.id.push(self.playcallFriends()[i].fantainId());
                } else {
                    for ( var i = 0; i < self.playcallFriends().length; i++)
                        if (self.playcallFriends()[i].playcallFriend())
                            temp.id.push(self.playcallFriends()[i].fantainId());
                    temp.id.push(self.user().fantainId());
                }
            return temp;
        });


        self.scheduleSeriesList = ko.computed( function() {
            var s = [], i=self.allSeries().length;
			while (i--) {
            //for (var i=0; i < self.allSeries().length; i++) {
                if (self.allSeries()[i].show())
                    s.indexOf(self.allSeries()[i].title()) == -1 ?
                        s.push(self.allSeries()[i].title()) : '';
            }
            return s.sort();
        }).extend({throttle:1});

        self.scheduleTeamList = ko.computed( function() {
            var s = [], i=self.allSeries().length;
			while (i--) {
            //for (var i=0; i < self.allSeries().length; i++) {
                if (self.allSeries()[i].show()) {
                    s.indexOf(self.allSeries()[i].playingTeam1()) == -1 ?
                        s.push(self.allSeries()[i].playingTeam1()) : '';
                    s.indexOf(self.allSeries()[i].playingTeam2()) == -1 ?
                        s.push(self.allSeries()[i].playingTeam2()) : '';
                }
            }
            return s.sort();
        }).extend({throttle:1});

        self.scheduleVenueList = ko.computed( function() {
            var s = [], i=self.allSeries().length;
			while (i--) {
            //for (var i=0; i < self.allSeries().length; i++) {
                if (self.allSeries()[i].show())
                    s.indexOf(self.allSeries()[i].venue()) == -1 ?
                        s.push(self.allSeries()[i].venue()) : '';
            }
            return s.sort();
        }).extend({throttle:1});

        //When you come into Playcall page, show team selector based on this condition
        self.revealTeamSelector = ko.computed ( function() {
            //This should fire only when we enter the play page the first time
            if (self.currPage != undefined && self.currPage() == 'fid-playPage' && self.loggedIn() && self.playingFor() == 0 && self.gameOn() && matchMedia(Foundation.media_queries.small).matches) {
                $('#fid-select-team-btn').trigger('click');
            }
            return true;
        });

        self.getPlayingForTeam = ko.computed ( function() {
            if(self.matchInfo() != null) {
              return self.playingFor() == self.matchInfo().team1() ? self.matchInfo().team1name() : self.matchInfo().team2name();
            } else {
              return '';
            }

        });

        self.noLiveMatchesText = ko.computed ( function() {
            if (self.liveMatches.length == 0) {
                if (self.waitTable().length > 0) {
                    return 'Checking for Live matches ...';
                } else
                    return 'No live matches currently scheduled';
            } else
                return '';
        });

        self.noNonLiveMatchesText = ko.computed ( function() {
            if (self.allSeries.length == 0) {
                if (self.waitTable().length > 0) {
                    return 'Checking for matches ...';
                } else
                    return 'No matches currently available for display';
            } else
                return '';
        });

    }
});
