/**
 * Created with JetBrains WebStorm.
 * User: aravind
 * Date: 14/8/13
 * Time: 9:08 AM
 * To change this template use File | Settings | File Templates.
 */

define(function () {
    return function fVMhome() {
        var self = this;

        //Data
        self.chosenHomeItem = ko.observable();
        self.storedNotifications = ko.observableArray([]);
        self.reminderSet = ko.observable("Not Set");

        self.gameScheduled = ko.observable(false);

        //Behaviour
        //This is if some actions need to be completed before home page is shown
        self.buildLaunchPage = function () {

            fg.fVM.setHeaderTitle('<span class="fc-installation-headerlogo"/></span>');
            fg.fVM.showPage('fid-launchPage', 'fc-pageAppear');

            //Get notifications and display them
            fg.cb.manageNotifications();

            //Check if a game is on & set details accordingly
            requirejs(['fantainUtils-gameOn'], function (checkGameOn) {
                //This checks if a game is on, and if it is, sets the ko variables accordingly
                fg.checkGameOn = new checkGameOn();
                fg.checkGameOn.setMatchInfo();

                fg.timerHandler.start('fg.checkGameOn.rteventsCheckComplete', true, true, 100, $.noop, function () {
                    if (!fg.fVM.gameOn() && !fg.fVM.gameScheduled()) {
                        fg.gotoPage = '#home';
                        fg.fantainMsgOkCallback = fg.gotoPageAction;
                        fg.fantainMsg('No real-time events scheduled now, check again soon!', fg.fantainMsgType.alert);
                    }
                });
            });
        };

        self.refreshGameOn = function() {
            requirejs(['fantainUtils-gameOn'], function (checkGameOn) {
                //This checks if a game is on, and if it is, sets the ko variables accordingly
                var cg = new checkGameOn();
                cg.setMatchInfo();
            });
        };

        self.setupReminder = function () {
            var reqData = {matchid: fg.fVM.matchInfo().id().toString() };
            fg.fVM.loggedIn() ? reqData.fantainid = fg.fVM.user().fantainId().toString() : reqData.regdid = fg.pushNotificationRegId;
            var pReminder = $.post(fg.svcPath + 'reminder/match', JSON.stringify(reqData));
            pReminder.done(function (reminderResponse) {
                if (reminderResponse.status == 'OK') {
                    fg.fVM.reminderSet("Set");
                } else {
                    fg.fantainMsgOkCallback = '';
                    fg.fantainMsg('Unable to set reminder, please try after sometime!', fg.fantainMsgType.alert);
                    fg.fVM.reminderSet('Not Set');
                }
                fg.fantainStore.set(fg.fVM.matchInfo().id().toString() + '-' + 'reminderSet', fg.fVM.reminderSet());
            });
        }

    }
});
