/**
 * Created with JetBrains WebStorm.
 * User: aravind
 * Date: 14/8/13
 * Time: 9:08 AM
 * To change this template use File | Settings | File Templates.
 */

define(function () {
    return function fVMleaderboard() {
        var self = this;

        //Data
        self.leaderboard = ko.observableArray([]);
        self.nameSort = 1, self.pointsSort = 1, self.rankSort = 1;
        var eachScore = ko.mapping.fromJS({});

        self.lifetimeScoreText = ko.observable('Lifetime');
        self.currentMatchText = ko.observable('Game');
        self.currentLB = ko.observable();

        self.lbMyFriendsText = ko.observable('My Friends');
        self.lbAll = ko.observable('All');
        self.currentLBFor = ko.observable();

        //A bunch of observables that are dependent on other data elements in fVM-init.js

        //This is if some actions need to be completed before play page is shown
        self.buildLeaderboardPage = function () {
            fg.fVM.setHeaderTitle('Leaderboard');
            //Always start with current match if one is in progress
            self.currentLB(fg.fVM.gameOn() ? fg.fVM.currentMatchText() : fg.fVM.lifetimeScoreText());
            //Start with friends for social logins
            self.currentLBFor(fg.fVM.user().userType() == fg.userType.fb ? fg.fVM.lbMyFriendsText() : fg.fVM.lbAll());

            self.getLeaderboard();

            fg.fVM.showPage('fid-leaderboardPage', 'flipInY');
            fg.actionComplete(fg.waitFor.load_page+"#leaderboard");

        };

        self.getLeaderboard = function () {
            requirejs(['fantainUtils-svc'], function(svc) {
                var s = new svc();
                s.svcCall({url:fg.svcPath + fg.fVM.leaderboardUrl(), type: 'POST', postData:fg.fVM.lbFriendsToSend(),
                    successCallback: self.leaderboardSuccess, errorCallback: self.leaderboardError, fantainSvc: true,
                    returnNode: 'board', wait: true});
            })

        }

        self.leaderboardError = function ( e ) {
            fg.fantainMsgOkCallback = $.noop;
            if (e.timeout)
                fg.fantainMsg('Possible network congestion, timeout trying to access leaderboard. Please try again later.', fg.fantainMsgType.alert);
            else
                fg.fantainMsg('Error: '+e.msg+' trying to access leaderboard.', fg.fantainMsgType.alert);
        }

        self.leaderboardSuccess = function(lb) {
            fg.fVM.leaderboard([]);
            //for (index in fantainResponse.board) {
            for (var index=0; index < lb.length; index++) {
                eachScore = ko.mapping.fromJS(lb[index]);
                eachScore.faceImage = ko.observable('');
                fg.fVM.leaderboard.push(eachScore);
            }

            //Sort by rank to start with
            fg.fVM.leaderboard.sort(fg.sortJson('rank',1));

            //Now load facebook profile pictures asynchronously
            //if (fg.fVM.user().userType() == fg.userType.fb)
            for (var i = 0; i < fg.fVM.leaderboard().length; i++ ) {
                if (fg.fVM.leaderboard()[i].fbid() != null)
                    fg.fVM.leaderboard()[i].faceImage('https://graph.facebook.com/' + fg.fVM.leaderboard()[i].fbid() + '/picture');
            }
        }

    }
});
