/**
 * Created with JetBrains WebStorm.
 * User: aravind
 * Date: 19/8/13
 * Time: 10:50 PM
 * To change this template use File | Settings | File Templates.
 * 
 */

define(function () {
    return function fVMlogin() {
        var self = this;

        //Data
        self.loggedIn = ko.observable(false);

        self.user = ko.observable({
            userType: ko.observable(fg.userType.none),

            fantainId: ko.observable(''),
            fbId: ko.observable(0),
            email: ko.observable(''),
            firstName: ko.observable('login'),
            lastName: ko.observable(''),
            joinDate: ko.observable(''),
            lastLogin: ko.observable(''),
            loginImg: ko.observable('images/notLoggedIn.jpg'),
            loginAlt: ko.observable('Not logged in'),
            profileLink: ko.observable("#login"),

            online: ko.observable(false),

            score: ko.observable(),
            friends: ko.observableArray([])
        });

        self.user.fullName = ko.computed(function () {
            return this.user().firstName() + " " + this.user().lastName();
        }, this);

        self.loginEmail = ko.observable();
        self.loginFirstName = ko.observable();
        self.loginLastName = ko.observable();

        self.rememberMe = ko.observable();

        self.showRegisterPage = ko.observable(false);

        //This is if some actions need to be completed before play page is shown
        self.buildLoginPage = function () {
            fg.fVM.setHeaderTitle('Login');

            fg.fVM.showPage('fid-loginPage', 'fc-pageAppear');
            fg.actionComplete(fg.waitFor.load_page+"#login");
        };

        self.goToLoginPage = function() {
            fg.sammyContext.redirect("#login");
        }

        self.goToFBLogin = function () {
            requirejs(['fantainUtils-login'], function (fantainLogin) {
                var fLogin = new fantainLogin;
                fLogin.loginToFB(fg.fVM.goBackFromLogin);
            });
            //loginToFB();
        };

        self.goToEmailLogin = function () {
            if (!fg.validateEmail(this.loginEmail())) {
                fg.fantainMsg('Please check your email address and try again.', fg.fantainMsgType.alert);
            } else {
                requirejs(['fantainUtils-login'], function (fantainLogin) {
                    var fLogin = new fantainLogin;
                    fLogin.loginToEmail(fg.fVM.loginEmail(), fg.fVM.rememberMe(), fg.fVM.goBackFromLogin);
                });
            }
        };

        self.goToEmailRegister = function () {
            if (fg.fVM.loginFirstName().length == 0 && fg.fVM.loginLastName().length == 0) {
                fg.fantainMsg('Can you give us some name to identify you with?', fg.fantainMsgType.alert);
            } else {
                requirejs(['fantainUtils-login'], function (fantainLogin) {
                    var fLogin = new fantainLogin;
                    fLogin.registerEmailUser(fg.fVM.loginEmail(), fg.fVM.rememberMe(), fg.fVM.loginFirstName(),
                        fg.fVM.loginLastName(), fg.fVM.goBackFromLogin);
                        $('a.close-reveal-modal').trigger('click');
                });
            }
        }

        self.goBackFromLogin = function () {
            fg.fVM.showRegisterPage(false); //Just in case
            window.history.back();
        };

        self.launchPrivacypolicy = function () {

            fg.debugMsg('Now starting inapp browser', fg.debugLevel.msgs);
            var ppWindow = window.open(fg.privacyPolicyUrl, '_blank', 'location=yes');
            fg.debugMsg('After starting inapp browser', fg.debugLevel.msgs);

        }

    }
});
