/**
 * Created with JetBrains WebStorm.
 * User: aravind
 * Date: 14/8/13
 * Time: 9:08 AM
 * To change this template use File | Settings | File Templates.
 */

define(function () {
    return function fVMnews() {
        var self = this;

        //Data
        self.newsFeed = ko.observableArray([]);
        self.newsFeedUpdatedAt = ko.observable('No updates yet');

        // Boolean
        self.pullToRefreshNews = ko.observable(false);


        // This is if some actions need to be completed before play page is shown
        self.buildNewsPage = function () {
            fg.fVM.setHeaderTitle('News');

            self.loadNewsFeed();

            fg.fVM.showPage('fid-newsPage', 'flipInY');
            fg.actionComplete(fg.waitFor.load_page+"#news");
        };

        // Load News Feed
        self.loadNewsFeed = function() {
            if (fg.fVM.online()) {
                fg.actionStarted(fg.waitFor.loading_news_feed);
                fg.rssFeed( fg.newsUrl, {ssl:true}, fg.fVM.bindNewsFeed );
                fg.stillLoadingNewsFeed = true;
            }
            else
            {
                var newsFeed = fg.fantainStore.get('newsFeed');
                if (newsFeed != null && newsFeed.entries.length > 0) {
                    fg.actionStarted(fg.waitFor.loading_news_feed);
                    fg.fVM.newsFeedUpdatedAt(fg.fantainStore.get('newsFeedUpdatedAt'));
                    fg.fVM.bindNewsFeed('stored', newsFeed);
                } else {
                    fg.fantainMsgOkCallback= $.noop;
                    fg.fantainMsg('No network connection & no previous items stored, try later!',fg.fantainMsgType.alert);
                }
            }
        };

        self.bindNewsFeed = function (status, feed) {
            if (status == 'error') {
                fg.actionComplete(fg.waitFor.loading_news_feed);
                fg.fantainMsgOkCallback = $.noop;
                fg.fantainMsg('Some error occurred getting news, try again later', fg.fantainMsgType.confirm);
            } else {

                var noOfPrevNewsFeedItems = fg.fVM.newsFeed().length;

                self.newsFeed.removeAll();

                var newsentry, newsexit;


                for (var i = 0; i < feed.entries.length; i++ ) {
                    newsentry = feed.entries[i];
                    newsexit = {};
                    newsexit.title = newsentry.title;
                    newsexit.publishedDate = fg.dates.formatDate(newsentry.publishedDate,'w, dd mmmm hh:mi 12');
                    newsexit.link = 'fid-newslink-'+newsentry.link;
                    newsexit.image = [];

                    //Handle the image tags
                    var x = fg.removeImg(newsentry.content);
                    newsentry.content = x[0];
                    newsexit.image = x.slice(1);

                    //Now handle the hyperlinks
                    newsexit.content = fg.replaceHref(newsentry.content, 'fid-newslink-');

                    fg.fVM.newsFeed.push(newsexit);
                }

                // list item fade in
                //fg.fVM.listItemFadeIn('.fc-news-list-item');

                if(fg.fVM.newsFeed().length > noOfPrevNewsFeedItems && noOfPrevNewsFeedItems > 0) {
                    fg.cb.inAppNotification( 'NewsFeed', 'New news items added', 'New News' );
                }


                if (status != 'stored') {
                    //First store it locally so it can be retrieved when connection is down
                    fg.actionStarted(fg.waitFor.local_store + 'news');
                    fg.fantainStore.clear('newsFeed');
                    fg.fantainStore.set('newsFeed', feed);
                    fg.fVM.newsFeedUpdatedAt(fg.dates.formatDate(new Date, 'dd-mmmm at hh:mi 12'));
                    fg.fantainStore.set('newsFeedUpdatedAt', fg.fVM.newsFeedUpdatedAt() );
                    fg.actionComplete(fg.waitFor.local_store + 'news');
                }

                fg.actionComplete(fg.waitFor.loading_news_feed);
                fg.stillLoadingNewsFeed = false;
                if(!fg.loadingNewsFeed) {
                    self.pullToRefreshNews(false);
                }


            }
        };

    };
});
