/**
 * Created with JetBrains WebStorm.
 * User: aravind
 * Date: 14/8/13
 * Time: 9:08 AM
 * To change this template use File | Settings | File Templates.
 */

define(function () {
        return function () {
            var self = this;

            //Data
            self.gameOn = ko.observable(false);
            self.gameOnCalled = ko.observable(false);

            self.matchInfo = ko.observable();
            self.cbMatchUrl = ko.observable();

            //TODO: Why the heck isn't matchInfo reflecting on the view?
            self.matchName = ko.observable();
            self.matchStart = ko.observable();
            self.team1 = ko.observable();
            self.team1name = ko.observable();
            self.team2 = ko.observable();
            self.team2name = ko.observable();

            self.playingFor = ko.observable(0);

            self.currentTicker = "tickerTwo";
            //self.matchTickerAnimate = ko.observable(true);
            self.matchScore = ko.observable('Not yet updated.');
            self.matchScoreAnimate = ko.observable(true);

            //Banners
            self.noQuestionsForTeam = ko.observable('...');

            //Quiz related
            self.quizArray = ko.observableArray();

            self.noOfQuestions = ko.computed(function () {
                return self.quizArray().length;
            }).extend({throttle:1});;

            self.noOfQuestionsOpen = ko.computed(function () {
                var noOfQuestionsOpen = 0;
                $.each(self.quizArray(), function (k, v) {
                    v.qstatus.value() == 'o' ? noOfQuestionsOpen++ : '';
                });
                return noOfQuestionsOpen;
            }).extend({throttle:1});

            self.noOfQuestionsAnswered = ko.computed(function () {
                var noOfQuestionsAnswered = 0;
                $.each(self.quizArray(), function (k, v) {
                    v.myanswer() != 0 ? noOfQuestionsAnswered++ : '';
                });
                return noOfQuestionsAnswered;
            }).extend({throttle:1});

            self.noOfQuestionsOpenUnanswered = ko.computed(function() {
                var noOfQuestionsOpenUnanswered = 0;
                $.each(self.quizArray(), function (k, v) {
                    v.qstatus.value() == 'o' && v.myanswer() == 0 ? noOfQuestionsOpenUnanswered++ : '';
                });
                return noOfQuestionsOpenUnanswered;
            }).extend({throttle:1});

            self.currQuizId = ko.observable(0);
            self.showAnswerPane = ko.observable(false);
            //self.currQuiz.status = ko.observable('');

            self.showFriendsSelector = ko.observable(false);
            self.friendsDisplayAnimate = ko.observable(true);

            self.setMatchInfo = function (matchInfo) {

                fg.fVM.matchInfo(ko.mapping.fromJS(matchInfo));

                //TODO: To be removed after matchInfo reflects on the view
                fg.fVM.matchName(fg.fVM.matchInfo().name());
                fg.fVM.matchScore(fg.fVM.matchInfo().start());
                fg.fVM.team1(fg.fVM.matchInfo().team1());
                fg.fVM.team1name(fg.fVM.matchInfo().team1name());
                fg.fVM.team2(fg.fVM.matchInfo().team2());
                fg.fVM.team2name(fg.fVM.matchInfo().team2name());

                fg.fVM.cbMatchUrl(fg.fVM.matchInfo().scoreurl());
            };

            self.unsetMatchInfo = function () {

                fg.fVM.matchInfo(null);

                //TODO: To be removed after matchInfo reflects on the view
                fg.fVM.matchName('');
                fg.fVM.matchScore('');
                fg.fVM.team1('');
                fg.fVM.team1name('');
                fg.fVM.team2('');
                fg.fVM.team2name('');

                fg.fVM.cbMatchUrl('');
            }

            //This is if some actions need to be completed before play page is shown
            self.buildPlayPage = function () {

                fg.fVM.setHeaderTitle('Playcall');

                //Setup score refresh using Cricbuzz feed
                //Currently not being used, will be turned on if we have score update live during Playcall
                //fg.fVM.updateScoreBox();

                //If matchinfo is not yet set, try again
                if (!fg.is(fg.fVM.matchInfo()))
                    requirejs(['fantainUtils-gameOn'], function (checkGameOn) {
                        //This checks if a game is on, and if it is, sets the ko variables accordingly
                        var cg = new checkGameOn();
                        cg.setMatchInfo();
                    });

                fg.fVM.showPage('fid-playPage', 'flipInY');
                fg.actionComplete(fg.waitFor.load_page+"#play");

                $('.fc-match-update-mobile-in').vTicker({
                    'pause':0
                });

                $('.fc-playcall-header-box-in').vTicker({
                    'pause':0
                });

                $('.fc-match-update-mobile-in').vTicker('pause', true);

                $('.fc-playcall-header-box-in').vTicker('pause', true);
            };

            self.updateScoreBox = function () {
                $.ajax({
                    type: 'GET',
                    url: fg.fVM.cbMatchUrl(),
                    async: false,
                    jsonpCallback: fg.jsonpCallback,
                    contentType: "application/json",
                    dataType: 'jsonp',
                    success: function (scorecard) {
                        if (scorecard[0].scorecard.match.state == 'preview')
                            fg.fVM.matchScore('Game not yet started, please stay tuned!')
                        else {
                            var msStatus = scorecard[0].scorecard.miniscorecard.status ?
                                scorecard[0].scorecard.miniscorecard.status.substring(0, scorecard[0].scorecard.miniscorecard.batteamname.length) == scorecard[0].scorecard.miniscorecard.batteamname ?
                                    scorecard[0].scorecard.miniscorecard.status.substring(scorecard[0].scorecard.miniscorecard.batteamname.length + 1) : scorecard[0].scorecard.miniscorecard.status : '';
                            fg.fVM.matchScore(scorecard[0].scorecard.miniscorecard.batteamname + ' ' + scorecard[0].scorecard.miniscorecard.batteamruns + '/' +
                                scorecard[0].scorecard.miniscorecard.batteamwkts + ' in ' + scorecard[0].scorecard.miniscorecard.batteamovers + (msStatus != '' ? ', ' + msStatus : ''));
                        }
                        fg.fVM.matchScoreAnimate(!fg.fVM.matchScoreAnimate());
                    },
                    error: function (e) {
                        console.log(e.message);
                    }
                });

                fg.playPageRefreshTimer = window.setTimeout(function () {
                    fg.fVM.updateScoreBox();
                }, fg.scorecardRefreshFreq * 1000);
            };

            self.playForTeam = function (selection) {

                fg.actionStarted(fg.waitFor.load_new_team);

                fg.fVM.playingFor(selection);
		        fg.fVM.currQuizId(0);
                fg.fVM.quizArray.removeAll();

                fg.fVM.gameOnCalled() ? fantain.fq.api.endgame() : '';
                fg.actionStarted(fg.waitFor.rt_gameon_called);
                //fantain.fq.api.gameon(fg.tenantId, Number(fg.fVM.user().fantainId()), fg.fVM.matchInfo().id(), selection.toString(),
                //    fg.geoloc.lat, fg.geoloc.lng, '0.0.0.0');
                //Sending nulls for geolocation for now
                fantain.fq.api.gameon(fg.tenantId, Number(fg.fVM.user().fantainId()), fg.fVM.matchInfo().id(), selection.toString(),
                    '','', '0.0.0.0');

                fg.fVM.gameOnCalled(true);
                fg.actionComplete(fg.waitFor.load_new_team);

            };


            self.reconnectRT = function() {
                if (fg.fVM.gameOnCalled()) {
                    fg.fVM.playForTeam(fg.fVM.playingFor());
                }
            };

            self.showQuestion = function (quizid) {
                fg.debugMsg('got qid :' + quizid, fg.debugLevel.msgs);
                if (fg.smallScreen) {
                    $('.playcall-pane-ct').css('overflow', 'hidden');
                }
                fg.fVM.showAnswerPane(true);
                fg.fVM.currQuizId(quizid);
            }


            self.closeQuestion = function () {
                if (fg.smallScreen) {
                    $('.playcall-pane-ct').css('overflow', 'auto');
                }
                fg.fVM.showAnswerPane(false);
                setTimeout(function(){
                    fg.fVM.currQuizId(0);
                },.5*1000);
            }

            self.choiceClicked = function (choice) {
                var quizIndex = fg.fVM.quizArray().indexOfPropertyValue('quizid', fg.fVM.currQuizId());
                if (fg.fVM.quizArray()[quizIndex].qstatus.value() == 'o') {
                    fg.debugMsg('got choice ' + choice + ' for ' + fg.fVM.currQuizId(), fg.debugLevel.msgs);
                    fantain.fq.api.quiz_response(fg.fVM.currQuizId(), choice);
                    fg.fVM.quizArray()[quizIndex].myanswer(choice);


                }
            }

            self.loadQuiz = function (quizArray) {
                fg.fVM.quizArray.removeAll();

                var d, displayTime;
                for (var i = 0; i < quizArray.length; i++) {

                    self.setQuizParams(quizArray[i]);
                    fg.fVM.quizArray.push(ko.mapping.fromJS(quizArray[i]));

                }
                $(document).foundation();
                fg.fVM.noQuestionsForTeam('No questions for this team yet');//This will be used if 0 questions returned
                fg.actionComplete(fg.waitFor.rt_gameon_called);
            }

            self.addQuiz = function (addedQuiz) {
                self.setQuizParams(addedQuiz);
                fg.fVM.quizArray.unshift(ko.mapping.fromJS(addedQuiz));
                $(document).foundation();

		        fg.cb.inAppNotification( 'newquiz', 'New Playcall Question Added', 'New Q' );

            }

            self.updateQuiz = function (updatedQuiz) {

                var updatedQuizIndex = fg.fVM.quizArray().indexOfPropertyValue('quizid',updatedQuiz.quizid);
                if (updatedQuizIndex == -1) {
                    //TODO: Is this the best way to handle this?
                    //Probably because it is a new quiz, so send to add
                    self.addQuiz(updatedQuiz);
                    //fg.fantainMsgOkCallback="";
                    //fg.fantainMsg('Oops! Got an update for an unknown quiz, ignoring', fg.fantainMsgType.alert);
                } else {
                    self.setQuizParams(updatedQuiz);
                    ko.mapping.fromJS(updatedQuiz, fg.fVM.quizArray()[updatedQuizIndex])
                    $(document).foundation();
                    fg.cb.inAppNotification( 'updatedquiz', 'A Playcall Question Has Been Modified', 'New Q' );
                }
            }

            self.answeredQuiz = function (answeredQuiz) {
                var updatedQuizIndex = fg.fVM.quizArray().indexOfPropertyValue('quizid',answeredQuiz.quizid);
                if (updatedQuizIndex == -1) {
                    fg.fantainMsgOkCallback="";
                    fg.fantainMsg('Oops! Got an update for an unknown quiz, ignoring', fg.fantainMsgType.alert);
                } else {
                    self.setQuizParams(answeredQuiz);
                    ko.mapping.fromJS(answeredQuiz, fg.fVM.quizArray()[updatedQuizIndex])
                }
            }

            self.setQuizParams = function(quizItem) {
                //TODO: Hack to address missing variables. To be removed after fixed in backend
                typeof quizItem.myanswer == 'undefined' ? quizItem.myanswer = 0 : '';
                typeof quizItem.correctanswer == 'undefined' ? quizItem.correctanswer = 0: '';
                typeof quizItem.score == 'undefined' ? quizItem.score = 0: '';
                if (fg.fVM.currQuizId() != 0) {
                    //Some question is being viewed currently
                    if (fg.fVM.currQuizId() != quizItem.quizid) {
                        quizItem.visible = ko.observable(false);
                    }
                } else {
                    quizItem.visible = ko.observable(true);
                }

                //Handle quiz responses
                typeof quizItem.responses == "undefined" ? quizItem.responses = 0: '';
                for (var i = 0; i < quizItem.choices.length ; i ++) {
                    typeof quizItem.choices[i].responses == "undefined" ? quizItem.choices[i].responses = 0 : '';
                    quizItem.choices[i].responsesPercent = quizItem.responses > 0 ?
                        Math.round((quizItem.choices[i].responses / quizItem.responses) * 100) + '%' : '';
                }

                //If question is closed, sort according to responses percent
                if (quizItem.qstatus.value == 'c') {
                    quizItem.choices.sort(fg.sortJson("responsesPercent",0))
                }

            }

            self.updateFriendScore = function (fantainid, lifetime, match) {
                for (var x = 0; x < fg.fVM.playcallFriends().length; x++) {
                    if (fg.fVM.playcallFriends()[x].fantainId() == fantainid) {
                        fg.fVM.playcallFriends()[x].score(match);
												//Ignoring friend's lifetime score in this update
                        break;
                    }
                }
                //Reorder the chosen friends so they are sorted, and inform the DOM
                fg.fVM.playcallFriends().sort(function (a, b) {
                    return a.score() < b.score() ? 1 : a.score() > b.score() ? -1 : 0;
                });
                fg.fVM.friendsDisplayAnimate(!fg.fVM.friendsDisplayAnimate());
                fg.fVM.playcallFriends.valueHasMutated();
            }

            self.updateMyScore = function (quizid, lifetime, match, quiz) {
                fg.fVM.user().score(lifetime);
                if (fg.fVM.user().userType() == fg.userType.fb)
                    fg.fVM.updateFriendScore(fg.fVM.user().fantainId(), null, match);
                else if (fg.fVM.user().userType() == fg.userType.email)
                    fg.fVM.playcallFriends()[0].score(match);
                if (quizid != null && quizid != 0) {
                    fg.fVM.quizArray()[fg.fVM.quizArray().indexOfPropertyValue('quizid',quizid)].score(quiz);
                }

            }

            self.getChoiceText = function (quizid, choiceid) {
                for (i=0; i < fg.fVM.quizArray()[quizid].choices().length; i++) {
                    if (fg.fVM.quizArray()[quizid].choices()[i].choiceid() == choiceid )
                        return fg.fVM.quizArray()[quizid].choices()[i].choicetext();
                }
                return '';
            }

            self.updateTicker = function(upd) {

                $("." + fg.fVM.currentTicker).html(upd);
                if (fg.fVM.currentTicker == "tickerOne" ) {
                    fg.fVM.currentTicker = "tickerTwo";
                } else {
                    fg.fVM.currentTicker = "tickerOne";
                }

                // Small
                $('.fc-match-update-mobile-in').vTicker('pause', false),
                    setTimeout(function() {
                        $('.fc-match-update-mobile-in').vTicker('pause', true)
                    }, 100);

                // Medium up
                $('.fc-playcall-header-box-in').vTicker('pause', false),
                    setTimeout(function() {
                        $('.fc-playcall-header-box-in').vTicker('pause', true)
                    }, 100);
            }
            self.matchClosed = function (match_id) {
                
                if (fg.fVM.matchInfo().id() == match_id && fg.fVM.gameOn() ) {

                    fg.fVM.unsetMatchInfo();
                    fg.fVM.quizArray.removeAll();
                    fg.fVM.gameOn(false);
                    fantain.fq.api.endgame();


                    if (fg.fVM.currPage() == 'fid-playPage') {
                        fg.gotoPage = 'launch';
                        fg.fantainMsgOkCallback = fg.gotoPageAction;
                    } else {
                        fg.fantainMsgOkCallback = $.noop;
                    }
                    fg.fantainMsg('The current Playcall match is closed, please join us for the next one. Thank you!',fg.fantainMsgType.alert);
                }
            }



        }
    }
);
