/**
 * Created with JetBrains WebStorm.
 * User: aravind
 * Date: 14/8/13
 * Time: 9:08 AM
 * To change this template use File | Settings | File Templates.
 */

define(function () {
    return function fVMprofile() {
        var self = this;

        //Data
        self.totalFBFriends = ko.observable(0);
        self.totalFBFriendsWithPlaycall = ko.observable(0);

        self.favourites = ko.observable({
            'teams': [],
            'players': [],
            'venues': []
        });

        self.favouritesList = ko.observable({
            'teams': [],
            'players': [],
            'venues': []
        });

        //This is if some actions need to be completed before play page is shown
        self.buildProfilePage = function () {
            fg.debugMsg('Building profile page for user ' + fg.fVM.user().fantainId(), fg.debugLevel.msgs);

            fg.fVM.setHeaderTitle('Profile');
            if (fg.fVM.user().userType() == fg.userType.fb) fg.fVM.getFriendsCount();

            fg.fVM.masterFavouritesList();

            fg.fVM.showPage('fid-profilePage', 'flipInY');
            fg.actionComplete(fg.waitFor.load_page+"#profile");

        }

        self.getFriendsCount = function () {
            FB.api('/me/friends', { fields: 'id, name, picture, installed' }, function (response) {
                if (response.error) {
                    alert(JSON.stringify(response.error));
                } else {
                    fg.fVM.totalFBFriends(response.data.length);
                    fg.fVM.totalFBFriendsWithPlaycall(0);
                    for (var i = 0; i < response.data.length; i++) {
                        if (response.data[i].installed) {
                            fg.fVM.totalFBFriendsWithPlaycall(fg.fVM.totalFBFriendsWithPlaycall() + 1);
                        }
                    }
                }
            });
        }

        self.postScoreOnFB = function (what, score) {
            var desc_fantain = what == 'total' ?
                'I am playing CAPTAIN of my favourite team & I have scored ' + score + ' FANPOINTS. You should try it too!' :
                'I am playing CAPTAIN of the game today, and have scored ' + score + ' FANPOINTS so far. Join in NOW!';

            var desc_srh = what == 'total' ?
                'I have scored ' + score + ' FANPOINTS on this app. You should try it too so we can play together!' :
                'I am playing the game today, and have scored ' + score + ' FANPOINTS so far. Join in NOW so we can play together!';

            FB.ui(
                {
                    method: 'feed',
                    name: fg.installation == 'srh' ? 'SunRisers Hyderabad' :'Fantain',
                    caption: fg.installation == 'srh' ? 'SunRisers Hyderabad Official App' : 'The coolest hangout for the sports fan!',
                    description: fg.installation == 'srh' ? desc_srh : desc_fantain,
                    link: 'https://play.google.com/store/apps/details?id=' + fg.androidPackageName,
                    picture: fg.installation == 'srh' ? 'http://fantain-i-prod.appspot.com/img/srh_logo.png': 'http://fantain-i-prod.appspot.com/img/fantain_logo.png'
                },
                function (response) {
                    fg.debugMsg('Got '+ response+ ' from Facebook', fg.debugLevel.msgs);
                    if (!response) {
                        fg.fantainMsgOkCallback='';
                        fg.fantainMsg('Your post could not be published, please check later');
                    } else {
                        fg.fantainMsgOkCallback='';
                        fg.fantainMsg('Thank you');
                    }
                }
            );
        }

        self.inviteFBFriends = function () {
            FB.ui({
                method: 'apprequests',
                filters: 'app_non_users',
                message: 'You should try Fantain! It is really cool and we could play together. Think you can beat me?',
            }, function (response) {
                fg.debugMsg('Got '+ response+ ' from Facebook', fg.debugLevel.msgs);
                fg.debugMsg('sendRequestInvite UI response: ', response.request_id, fg.debugLevel.error);
            });

        };

        self.logout = function () {
            requirejs(['fantainUtils-login'], function (fantainLogin) {
                var fLogin = new fantainLogin();
                (fg.fVM.user().userType() == fg.userType.fb) ? fLogin.logoutOfFB(fg.fVM.backOutOfProfilePage) : fLogin.logoutOfEmail(fg.fVM.backOutOfProfilePage);
            });
        };

        self.backOutOfProfilePage = function () {
            fg.sammyContext.redirect("#launch");
        }

        self.masterFavouritesList = function () {
            //$.ajaxSetup({async: false});

            self.favouritesList().teams = [];
            $.getJSON(fg.svcPath + "team", function (teamsList) {
                if (teamsList.status != 'OK') {
                    fg.debugMsg('Error getting list of teams, needs attention!', fg.debugLevel.errors);
                } else {
                    $(teamsList.teams).each(function (k, v) {
                        self.favouritesList().teams.push({name: v.name, isFav: ko.observable(false)});
                    });
                    self.updatesFavouritesListStatus();
                    self.favouritesList.valueHasMutated();
                }
            });

            self.favouritesList().players = [];
            $.getJSON(fg.svcPath + "players", function (playersList) {
                if (playersList.status != 'OK') {
                    fg.debugMsg('Error getting list of players, needs attention!', fg.debugLevel.errors);
                } else {
                    $(playersList.players).each(function (k, v) {
                        self.favouritesList().players.push({name: v.name, isFav: ko.observable(false)});
                    });
                    self.updatesFavouritesListStatus();
                    self.favouritesList.valueHasMutated();
                }
            });
            self.favouritesList().venues = [];
            $.getJSON(fg.svcPath + "venues", function (venuesList) {
                if (venuesList.status != 'OK') {
                    fg.debugMsg('Error getting list of venues, needs attention!', fg.debugLevel.errors);
                } else {
                    $(venuesList.venues).each(function (k, v) {
                        self.favouritesList().venues.push({name: v.name, isFav: ko.observable(false)});
                    });
                    self.updatesFavouritesListStatus();
                    self.favouritesList.valueHasMutated();
                }
            });

            //$.ajaxSetup({async: true});

        }
        // Favourite items
        self.updatesFavouritesListStatus = function() {
            var i = self.favouritesList().teams.length;
            while (i--) {
                if (self.favourites().teams.indexOf(self.favouritesList().teams[i].name) > -1) {
                    self.favouritesList().teams[i].isFav(true);
                } else {
                    self.favouritesList().teams[i].isFav(false);
                }
            }
        }

        self.updateFavouritesStatus = ko.computed (function() {
            var i = self.favouritesList().teams.length;
            while (i--) {
                var index = self.favourites().teams.indexOf(self.favouritesList().teams[i].name);
                if (self.favouritesList().teams[i].isFav()) {
                    if (index == -1)
                        self.favourites().teams.push(self.favouritesList().teams[i].name);
                } else {
                    if (index > -1)
                        self.favourites().teams.splice(index, 1);
                }
            }
            self.favourites.valueHasMutated();
        });

        // Favourite Players
        self.updatesFavouritesListStatusPlayers = function() {
            var i = self.favouritesList().players.length;
            while (i--) {
                if (self.favourites().players.indexOf(self.favouritesList().players[i].name) > -1) {
                    self.favouritesList().players[i].isFav(true);
                } else {
                    self.favouritesList().players[i].isFav(false);
                }
            }
        }

        self.updateFavouritesStatusPlayers = ko.computed (function() {
            var i = self.favouritesList().players.length;
            while (i--) {
                var index = self.favourites().players.indexOf(self.favouritesList().players[i].name);
                if (self.favouritesList().players[i].isFav()) {
                    if (index == -1)
                        self.favourites().players.push(self.favouritesList().players[i].name);
                } else {
                    if (index > -1)
                        self.favourites().players.splice(index, 1);
                }
            }
            self.favourites.valueHasMutated();
        });

        // Favourite venues
        self.updatesFavouritesListStatusVenues = function() {
            var i = self.favouritesList().venues.length;
            while (i--) {
                if (self.favourites().venues.indexOf(self.favouritesList().venues[i].name) > -1) {
                    self.favouritesList().venues[i].isFav(true);
                } else {
                    self.favouritesList().venues[i].isFav(false);
                }
            }
        }

        self.updateFavouritesStatusVenues = ko.computed (function() {
            var i = self.favouritesList().venues.length;
            while (i--) {
                var index = self.favourites().venues.indexOf(self.favouritesList().venues[i].name);
                if (self.favouritesList().venues[i].isFav()) {
                    if (index == -1)
                        self.favourites().venues.push(self.favouritesList().venues[i].name);
                } else {
                    if (index > -1)
                        self.favourites().venues.splice(index, 1);
                }
            }
            self.favourites.valueHasMutated();
        });

        // Save Favourites
        self.saveFavourites = function () {
            var reqData = fg.fVM.favourites();
            reqData.fantainId = fg.fVM.user().fantainId();
            var posting = $.post(fg.svcPath + 'preferences', JSON.stringify(fg.fVM.favourites()));
            posting.done(function (resp) {
                if (resp.status != "OK") {
                    fg.debugMsg('Unable to save preferences, please check', fg.debugLevel.errors);
                }
                ;
            });
        }

    }

});
