/**
 * Created with JetBrains WebStorm.
 * User: aravind
 * Date: 14/8/13
 * Time: 9:08 AM
 * To change this template use File | Settings | File Templates.
 */

define(function () {
    return function fVMschedule() {
        var self = this;

        //Data
        self.liveMatches = ko.observableArray([]);
        self.liveMatchesUpdatedAt = ko.observable();
        self.allSeries = ko.observableArray([]);
        self.allSeriesUpdatedAt = ko.observable();

        self.scheduleSorter = ko.observable(0);
        //self.scheduleTeamList = ko.observableArray([]);
        self.scheduleTeamSelected = ko.observable();
        //self.scheduleSeriesList = ko.observableArray([]);
        self.scheduleSeriesSelected = ko.observable();
        //self.scheduleVenueList = ko.observableArray([]);
        self.scheduleVenueSelected = ko.observable();

        self.liveScheduleText = ko.observable('Live');
        self.resultsScheduleText = ko.observable('Results');
        self.upcomingScheduleText = ko.observable('Upcoming');
        self.currentSchedule = ko.observable();
        self.pullToRefreshSchedule = ko.observable(false);

        //Startup
        self.currentSchedule(self.liveScheduleText());

        //This is if some actions need to be completed before play page is shown
        self.buildSchedulePage = function () {

            fg.fVM.setHeaderTitle('Schedule');

            fg.fVM.loadSchedules();

            fg.fVM.showPage('fid-schedulePage', 'flipInY');
            fg.actionComplete(fg.waitFor.load_page + "#schedule");

        };

        self.loadSchedules = function() {
            if (fg.fVM.online()) {

                if (fg.fVM.liveMatches().length == 0 && fg.fVM.currentSchedule() == fg.fVM.liveScheduleText()) {
                    fg.fVM.updateLiveMatches($.noop);
                } else
                if (fg.fVM.allSeries().length == 0 &&
                    (fg.fVM.currentSchedule() == fg.fVM.resultsScheduleText() || fg.fVM.currentSchedule() == fg.fVM.upcomingScheduleText())) {
                    fg.fVM.updateAllSeries();
                }
            }
            else {

                if (fg.fVM.liveMatches().length == 0 && fg.fVM.currentSchedule() == fg.fVM.liveScheduleText()) {
                    var liveMatches = fg.fantainStore.get('liveMatches');
                    if (liveMatches != null && liveMatches.length > 0) {
                        fg.fVM.liveMatchesUpdatedAt(fg.fantainStore.get('liveMatchesUpdatedAt'));
                        fg.fVM.updateLiveMatchesSuccess(liveMatches,'stored');
                    } else {
                        fg.fantainMsgOkCallback = $.noop;
                        fg.fantainMsg('Looks like the connection is down, try later!', fg.fantainMsgType.alert);
                    }
                } else
                if (fg.fVM.allSeries().length == 0 &&
                    (fg.fVM.currentSchedule() == fg.fVM.resultsScheduleText() || fg.fVM.currentSchedule() == fg.fVM.upcomingScheduleText())) {
                    var allSeries = fg.fantainStore.get('allSeries');
                    if (allSeries != null && allSeries.length > 0) {
                        fg.fVM.allSeriesUpdatedAt(fg.fantainStore.get('allSeriesUpdatedAt'));
                        fg.fVM.updateAllSeriesSuccess(allSeries,'stored');
                    } else {
                        fg.fantainMsgOkCallback = $.noop;
                        fg.fantainMsg('Looks like the connection is down, try later!', fg.fantainMsgType.alert);
                    }
                }

            }
        }

        self.updateLiveMatches = function (callback) {
            requirejs(['fantainUtils-svc'], function (svc) {
                fg.actionStarted(fg.waitFor.get_schedule);
                var s1 = new svc();
                var noOfPrevLiveScheduleItems;
                fg.stillLoadingLiveSchedules = true;
                s1.svcCall({url: fg.liveMatches, type: 'GET', dataType: 'jsonp', jsonpCallback: fg.jsonpCallback,
                    fantainSvc: false, wait: true,
                    successCallback: fg.fVM.updateLiveMatchesSuccess,
                    errorCallback: fg.fVM.cbCallsErrored
                });
            });
        };

        self.updateLiveMatchesSuccess = function(data, status) {

            var matchList = data[0].matches.match;
            noOfPrevLiveScheduleItems = fg.fVM.liveMatches().length;
            fg.fVM.liveMatches.removeAll();
            //for (i in matchList) {
            for (var i = 0; i < matchList.length; i++) {

                if (fg.seriesFilter.indexOf(matchList[i].series) > -1 || fg.seriesFilter.length == 0) {

                    matchList[i].startUTC = fg.dates.CBToUTCDateTime(matchList[i].startdate, matchList[i].starttimeGMT, 'ddmm');
                    matchList[i].startUTCtime = fg.dates.MatchstartTime(matchList[i].starttimeGMT);
                    matchList[i].hideForSmall = ko.observable(false);
                    if (typeof matchList[i].miniscorecard != 'undefined') {
                        matchList[i].miniscorecard.status = fg.scoresDelayedBy(matchList[i].miniscorecard.status);
                    }

                    fg.fVM.liveMatches.push(ko.mapping.fromJS(matchList[i]));
                }
            }

            // list item fade in
            //fg.fVM.listItemFadeIn('.fc-schedule-live-row');

            if (fg.fVM.liveMatches().length > noOfPrevLiveScheduleItems && noOfPrevLiveScheduleItems > 0) {
                fg.cb.inAppNotification('LiveSchedule', 'New Live Matches Added', 'New Matches');
            }


            if (status != 'stored') {
                fg.actionStarted(fg.waitFor.local_store + 'liveMatches');
                //First store it locally so it can be retrieved when connection is down
                fg.fantainStore.clear('liveMatches');
                fg.fantainStore.set('liveMatches', data);
                fg.fVM.liveMatchesUpdatedAt(fg.dates.formatDate(new Date, 'dd-mmmm at hh:mi 12'));
                fg.fantainStore.set('liveMatchesUpdatedAt', fg.fVM.liveMatchesUpdatedAt() );
                fg.actionComplete(fg.waitFor.local_store + 'liveMatches');
            }

            fg.actionComplete(fg.waitFor.get_schedule);
            fg.stillLoadingLiveSchedules = false;
            if (!fg.loadingLiveSchedules) {
                self.pullToRefreshSchedule(false);
            }

        };

        self.updateAllSeries = function () {
            requirejs(['fantainUtils-svc'], function (svc) {
                fg.actionStarted(fg.waitFor.get_schedule);
                fg.stillLoadingResultsSchedule = true;
                var s = new svc();
                var noOfPrevAllSeriesScheduleItems;
                s.svcCall({url: fg.seriesSchedule, type: 'GET', dataType: 'jsonp', jsonpCallback: fg.jsonpCallback,
                    fantainSvc: false, wait: true,
                    successCallback: fg.fVM.updateAllSeriesSuccess,
                    errorCallback: fg.fVM.cbCallsErrored
                });
            });
        };

        self.updateAllSeriesSuccess = function (seriesScheduleResponse, status) {

            var seriesList = seriesScheduleResponse[0]['schedule']['series'];
            noOfPrevAllSeriesScheduleItems = fg.fVM.allSeries().length;
            //for (i in seriesList) {
            fg.fVM.allSeries.removeAll();
            fg.fVM.clearScheduleFilters();
            for (var i = 0; i < seriesList.length; i++) {
                if (fg.seriesFilter.indexOf(seriesList[i].title) > -1 || fg.seriesFilter.length == 0) {

                    series = seriesList[i].title;

                    $.each(seriesList[i]['matches'], function (key, value) {
                        value.playingTeam1 = value.team1 == null ? 'TBC' : value.team1;
                        value.playingTeam2 = value.team2 == null ? 'TBC' : value.team2;
                        value.startUTC = fg.dates.CBToUTCDateTime(
                            value.startdate, value.starttimeGMT, 'mmdd');

                        value.title = series;
                        value.show = ko.observable(true);
                        value.hideForSmall = ko.observable(false);

                        fg.fVM.allSeries.push(ko.mapping.fromJS(value));

                    });
                }
            };
            fg.fVM.showCorrectSchedule();

            // list item fade in
            //fg.fVM.listItemFadeIn('.fc-schedule-all-series-row');

            if (fg.fVM.allSeries().length > noOfPrevAllSeriesScheduleItems && noOfPrevAllSeriesScheduleItems > 0) {
                fg.cb.inAppNotification('AllSeries', 'New Matches Added', 'New Matches');
            }

            if (status != 'stored') {
                //First store it locally so it can be retrieved when connection is down
                fg.actionStarted(fg.waitFor.local_store + 'allSeries');
                fg.fantainStore.clear('allSeries');
                fg.fantainStore.set('allSeries', seriesScheduleResponse);
                fg.fVM.allSeriesUpdatedAt(fg.dates.formatDate(new Date, 'dd-mmmm at hh:mi 12'));
                fg.fantainStore.set('allSeriesUpdatedAt', fg.fVM.allSeriesUpdatedAt() );
                fg.actionComplete(fg.waitFor.local_store + 'allSeries');
            }

            fg.actionComplete(fg.waitFor.get_schedule);
            fg.stillLoadingResultsSchedule = false;
            if (!fg.loadingResultsSchedule) {
                self.pullToRefreshSchedule(false);
            }

        }

        self.cbCallsErrored = function () {
            fg.actionComplete(fg.waitFor.get_schedule);
            fg.fVM.pullToRefreshSchedule(false);
            fg.fantainMsgOkCallback = $.noop;
            fg.fantainMsg('Some error occurred getting schedules, try later!', fg.fantainMsgType.alert);
        }

        self.showCorrectSchedule = function () {
            fg.actionStarted(fg.waitFor.show_schedule);
            for (var i = 0; i < fg.fVM.allSeries().length; i++)
                fg.fVM.allSeries()[i].show(
                        (
                            (fg.dates.isBeforeToday(fg.fVM.allSeries()[i].startUTC()) && fg.fVM.currentSchedule() == fg.fVM.resultsScheduleText()) ||
                            (fg.dates.isAfterToday(fg.fVM.allSeries()[i].startUTC()) && fg.fVM.currentSchedule() == fg.fVM.upcomingScheduleText())
                            ) &&
                        (fg.fVM.scheduleTeamSelected() === undefined ||
                            fg.fVM.allSeries()[i].playingTeam1() == fg.fVM.scheduleTeamSelected() ||
                            fg.fVM.allSeries()[i].playingTeam2() == fg.fVM.scheduleTeamSelected()
                            ) &&
                        (fg.fVM.scheduleVenueSelected() === undefined ||
                            fg.fVM.allSeries()[i].venue() == fg.fVM.scheduleVenueSelected()
                            ) &&
                        (fg.fVM.scheduleSeriesSelected() === undefined ||
                            fg.fVM.allSeries()[i].title() == fg.fVM.scheduleSeriesSelected()
                            )
                );
            // list item fade in
            //fg.fVM.listItemFadeIn('.fc-schedule-all-series-row');
            fg.actionComplete(fg.waitFor.show_schedule);
        };

        self.clearScheduleFilters = function() {
            fg.fVM.scheduleSeriesSelected(undefined);
            fg.fVM.scheduleTeamSelected(undefined);
            fg.fVM.scheduleVenueSelected(undefined);
        };

    };
});



