/**
 * Created with JetBrains WebStorm.
 * User: aravind
 * Date: 14/8/13
 * Time: 9:08 AM
 * To change this template use File | Settings | File Templates.
 */

define(function () {
    return function fVMscores() {
        var self = this;

        //Data
        self.scorecardUrl = ko.observable('');
        self.scorecard = ko.observableArray([]);
        var eachScorecard = ko.mapping.fromJS({});

        self.showDetailedScorecard = ko.observable(false);
        self.showSummaryScorecard = ko.computed(function () {
            return !self.showDetailedScorecard();
        });
        self.activeInnings = ko.observable(1);

        //This is if some actions need to be completed before play page is shown
        self.buildScoresPage = function () {
            fg.fVM.setHeaderTitle('Scores');

            if (fg.fVM.online()) {
                fg.fVM.showDetailedScorecard(false);
                fg.fVM.scorecard([]);
                fg.fVM.getScores();
            } else {
                fg.fantainMsg('Looks like the connection is down, try later!', fg.fantainMsgType.alert);
            }

            fg.fVM.showPage('fid-scoresPage', 'flipInY');
            ////fg.actionComplete();

        };

        self.refreshScores = function () {
            if (fg.fVM.scorecard()[0].match.state() != 'complete')
                fg.scoresPageRefreshTimer = window.setTimeout(function () {
                    fg.fVM.getScores();
                }, fg.scorecardRefreshFreq * 1000);
        }

        self.getScores = function () {
            //fg.fVM.scorecard([]);
            fg.actionStarted(fg.waitFor.get_scorecard);
            fg.debugMsg('Refreshing scorecard ... ', fg.debugLevel.msgs);
            $.ajax({
                type: 'GET',
                url: fg.fVM.scorecardUrl(),
                async: false,
                jsonpCallback: fg.jsonpCallback,
                contentType: "application/json",
                dataType: 'jsonp',
                success: function (scorecardResponse) {
                    eachScorecard = ko.mapping.fromJS(scorecardResponse[0].scorecard);
                    eachScorecard.match.startUTC = fg.dates.CBToUTCDateTime(eachScorecard.match.startdate(), eachScorecard.match.starttimeGMT(), 'ddmm');
                    eachScorecard.match.status (fg.scoresDelayedBy(eachScorecard.match.status()));


                    //Computations & corrections. Whew!
                    //Add current run rate to miniscorecard
                    if (eachScorecard.miniscorecard) {
                        eachScorecard.miniscorecard.crr = ko.computed(function () {
                            var overs = Number(eachScorecard.miniscorecard.batteamovers().split(".")[0]) +
                                (Number(eachScorecard.miniscorecard.batteamovers().split(".")[1]) ?
                                    Number(eachScorecard.miniscorecard.batteamovers().split(".")[1]) : 0) / 6;
                            return (eachScorecard.miniscorecard.batteamruns() / overs).toFixed(2);
                        });
                        //Modify balls-faced to ballsfaced for each batsman. Add strike rate also. Shorten the name.
                        $.each(eachScorecard.miniscorecard.batsman(), function (key, value) {
                            value.ballsfaced = value['balls-faced']();
                            value.sr = (value.runs() / value.ballsfaced * 100).toFixed(2);
                            value.shortName = fg.shortenName(value.name());
                        });
                        //Add Economy to bowlers data. Shorten the name.
                        $.each(eachScorecard.miniscorecard.bowler(), function (key, value) {
                            var overs = Number(value.overs().split(".")[0]) +
                                (Number(value.overs().split(".")[1]) ? Number(value.overs().split(".")[1]) : 0) / 6;
                            value.ec = (value.runs() / overs ).toFixed(2);
                            value.shortName = fg.shortenName(value.name());
                        });
                        //Handle the CDATA mess in prevOvers
                        if (typeof eachScorecard.miniscorecard.prevOvers != 'undefined') {
                            var po = eachScorecard.miniscorecard.prevOvers();
                            po = po.substring(9, po.length - 4).split('<b>&nbsp;&nbsp;|&nbsp;&nbsp;</b>').join('| ');
                            eachScorecard.miniscorecard.po = po.substring((po.length - 35) > 0 ? po.length - 35 : 0);
                            eachScorecard.miniscorecard.poa = po.split(' ');
                        }
                    }

                    if (eachScorecard.innings) {
                        $.each(eachScorecard.innings(), function (innKey, innValue) {
                            $.each(innValue.batteam.players(), function (playerKey, playerValue) {
                                playerValue.player.sr = (playerValue.player.runs() / playerValue.player.balls() * 100).toFixed(2);
                                playerValue.player.shortName = fg.shortenName(playerValue.player.name());
                                playerValue.player.shortName += playerValue.player.captain() == 'yes' ? '*' : '';
                                playerValue.player.shortName += playerValue.player.keeper() == 'yes' ? '(wk)' : '';
                                playerValue.player.batStatus = playerValue.player.status().substring(9, playerValue.player.status().length - 3);
                            });
                            $.each(innValue.bowlteam.players(), function (playerKey, playerValue) {
                                playerValue.player.eco = (playerValue.player.runsoff() / playerValue.player.overs()).toFixed(2);
                            });
                        });
                    }

                    fg.fVM.scorecard.pop();
                    fg.fVM.scorecard.push(eachScorecard);
                    //fg.fVM.scorecard()[0]=eachScorecard;

                    $('.fc-over-scorepart').scrollLeft(800);

                    //Put scores refresh in a loop when scores page is shown for matches that are not complete
                    if (eachScorecard.match.state() != 'complete')
                        fg.scoresPageRefreshTimer = window.setTimeout(function () {
                            fg.fVM.getScores();
                        }, fg.scorecardRefreshFreq * 1000);

                    fg.actionComplete(fg.waitFor.get_scorecard);

                },
                error: function (e) {
                    fg.actionComplete(fg.waitFor.get_scorecard);
                    fg.debugMsg('Some error occurred retrieving scorecard: '+e.message, fg.debugLevel.msgs);
                }
            });
        };

    };
});
