/**
 * Created with JetBrains WebStorm.
 * User: aravind
 * Date: 14/8/13
 * Time: 9:55 AM
 * To change this template use File | Settings | File Templates.
 */

fg.cb = {

    /*********** Device ready & Kick-off ********************/
    deviceReady: function () {

        if (fg.isApp) {

            fg.debugMsg('Device Ready ...', fg.debugLevel.msgs);

            //fg.debugMsg('Loading the splash screen ...', fg.debugLevel.msgs);
            navigator.splashscreen.show();

            //Setup all the listeners
            document.addEventListener("online", fg.cb.onOnline, false);
            document.addEventListener("offline", fg.cb.onOffline, false);
            document.addEventListener("pause", fg.cb.onPause, false);
            document.addEventListener("resume", fg.cb.onResume, false);
            document.addEventListener("menubutton", fg.cb.onMenuButton, false);
            document.addEventListener("searchbutton", fg.cb.onSearchButton, false);
            document.addEventListener("backbutton", fg.cb.onBackButton, false);

            //This is set / unset in the onPause / onResume events, inapp notifications behave
            //differently based on whether this is true or not
            fg.inForeground = true;

            //This is if we need to trap an in-app notification for processing
            window.plugin.notification.local.onclick = function (id, state, json) {
                //alert('Notification clicked :'+id+state+json);
            };

            window.plugin.notification.local.oncancel = function (id, state, json) {
                //alert('Notification cancelled :'+id+state+json);
            };

        }

        /*  The following kicks off the whole shibang ...
         First load all htmls into the dom so subsequent rendering is fast
         Then call fantainRoutes that will kick things off based on the URL
         ---------------------------------------------------- */
        requirejs(['fantainHtml', 'fantainInteract', 'fantainRoutes', 'fantainAnimations', 'fantainScrDim'], function () {
            startSammy();
        });

        //Setup Google Analytics plugin
        requirejs(['fantainAnalytics'], function () {
            requirejs(['GA'], function () {
                fg.gaPlugin = fg.isApp ? window.plugins.gaPlugin : gaplugins;
                fantain.analytics.init();
            });
        });

        //Check and setup connectivity status
        fg.checkConnectivity();

        //If device, register for push notification
        if (fg.isApp) {
            //Setup Notification
            requirejs(['pushNotification'], function () {

                //fg.fantainStore.clear('pushNotificationRegId'); //Temporary, for testing
                //alert('got from fantainstore: '+ fg.fantainStore.get('pushNotificationRegId'));

                if (fg.fantainStore.get('pushNotificationRegId') == null) {
                    fg.debugMsg('No previous notification, about to set one', fg.debugLevel.msgs);
                    try {
                        fg.pushNotification = window.plugins.pushNotification;
                        if (device.platform == 'android' || device.platform == 'Android') {

                            fg.pushNotification.register(
                                fg.cb.pushNotificationSuccess,
                                fg.cb.pushNotificationError,
                                {
                                    "senderID": fg.GCMID,
                                    "ecb": "onNotificationGCM"
                                });
                        }
                        else {
                            fg.pushNotification.register(
                                fg.cb.pushNotificationSuccess,
                                fg.cb.pushNotificationError,
                                {
                                    "badge": "true",
                                    "sound": "true",
                                    "alert": "true",
                                    "ecb": "onNotificationAPN"
                                });
                        }
                    } catch (err) {
                        fg.debugMsg("Push notification error: " + err.message, fg.debugLevel.errors);
                    }
                }
            });
        }

        //Pick up settings or fallback to what's in fantainGlobals
        requirejs(['fantainUtils-svc'], function (svc) {
            var s = new svc();
            s.svcCall({
                url: fg.settingsFrom, type: 'GET',
                successCallback: function (settings) {
                    $.each(settings, function (k, v) {
                        fg[k] = v;
                    });
                },
                errorCallback: function () {
                    fg.debugMsg("Didn't get settings, falling back to defaults", fg.debugLevel.errors);
                },
                returnNode: 'settings', fantainSvc: true,
                wait: false});
        });


    },

    //Callbacks
    onOnline: function () {
        fg.debugMsg('Online now!', fg.debugLevel.msgs);
        fg.online = true;
        fg.is(fg.fVM.online) ? fg.fVM.online(fg.online) : '';
        if (!fg.firstTime) fg.checkConnectivity();

    },


    onOffline: function () {

        fg.debugMsg('Oops, lost internet connection', fg.debugLevel.msgs);
        fg.online = false;
        fg.alive = false;
        fg.is(fg.fVM.online) ? fg.fVM.online(fg.online) : '';
        fg.is(fg.fVM.alive) ? fg.fVM.alive(fg.alive) : '';
        if (!fg.firstTime) {
            fg.fantainMsgOkCallback = $.noop;
            fg.fantainMsg('Oops ... Lost internet connection, please reconnect', fg.fantainMsgType.alert);
        }

    },

    onPause: function () {
        fg.debugMsg('Paused!', fg.debugLevel.msgs);
        fg.inForeground = false;
    },

    onResume: function () {
        fg.debugMsg('Resumed!', fg.debugLevel.msgs);
        fg.inForeground = true;
        fg.cb.onOnline(); //Restore connection status when resuming
    },

    onMenuButton: function () {
        fg.debugMsg('Menu button pressed!', fg.debugLevel.msgs);

        fg.closeOverlays();

        if ($('.off-canvas-wrap.move-right').length == 0) {
            $('.off-canvas-wrap').addClass('move-right');
        }
    },

    onSearchButton: function () {
        fg.debugMsg('Search button pressed!', fg.debugLevel.msgs);
    },

    continueWithApp: function () {
        //If you get here, you must have accepted the T&Cs
        fg.fantainStore.set('termsAndConditionsAccepted', true);
        //If on an older version, exit if version needs to be updated
        if ( fg.isApp && fg.versionCode < fg.serverVersionCode ) {
            fantain.analytics.sendevent(["app", "old_version", null, fg.versionCode]);
            fg.fantainMsgOkCallback = fg.cb.exitFromApp;
            fg.fantainMsg('You seem to be on an older version. Please go to Playstore and upgrade to the current version to use the app', fg.fantainMsgType.alert);
        }
        //If notification launch, then go to the page indicated by that
        else if (fg.coldstartaction == 'gotoPage') {
            fantain.analytics.sendevent(["app", "notification", "cold_start", 1])
            fg.sammyContext.redirect("#" + fg.gotoPage);
            fg.gotoPage = '';
            fg.coldstartaction = '';
        }
        //If not online, give that message
        else if (!fg.fVM.online()) {
            fg.gotoPage = '#home';
            fg.fantainMsgOkCallback = fg.gotoPageAction;
            fg.fantainMsg('Not online, some features require a connection to work', fg.fantainMsgType.alert);
        }
        //If not alive, give that message
        else if (!fg.fVM.alive()) {
            fg.gotoPage = '#home';
            fg.fantainMsgOkCallback = fg.gotoPageAction;
            //fg.fantainMsg('Fantain server status: ' + fg.pingError +'. Press OK to go to Home page', fg.fantainMsgType.alert);
            fg.fantainMsg('Slow network, unable to reach Fantain servers now. Press OK to go to Home page', fg.fantainMsgType.alert);
        }
        //Or go to the launch page
        else {
            fg.sammyContext.redirect("#launch");
        }

    },

    exitFromApp: function () {
        fg.fantainStore.clear('pushNotificationRegId');
        fg.fantainStore.clear('pushNotificationUser');
        navigator.app.exitApp();
    },

    onBackButton: function () {
        fg.debugMsg('Back button pressed!', fg.debugLevel.msgs);

        if (!fg.handleBackButton()) {

            if (fg.is(fg.fVM.currPage) && (fg.fVM.currPage() == 'fid-homePage' || fg.fVM.currPage() == 'fid-launchPage' )) {
                fg.fantainMsgOkCallback = fg.cb.exitFromApp;
                fg.fantainMsgCancelCallback = '';
                fg.fantainMsg('Press OK to exit the application', fg.fantainMsgType.confirm);
            } else {
                window.history.back();
            }

        }

    },

    permissionCallback: function (button) {
        if (button === 1)
            fg.gaPlugin.init(fg.GAsuccessHandler, fg.GAerrorHandler, fg.GAUA, 10);
    },


    //Notification related callbacks
    pushNotificationSuccess: function (result) {
        fg.debugMsg('Push notification success, result = ' + result, fg.debugLevel.msgs);
    },

    pushNotificationError: function (error) {
        fg.debugMsg('Push notification failed, error = ' + error, fg.debugLevel.errors);
    },

    //Store Notifications & Update VM when possible
    manageNotifications: function (msg) {
        var s = fg.fantainStore.get('storedNotifications');
        var sn = (s != null && s != 'undefined') ? s : [];
        if (msg) {
            sn.push({id: sn.length + 1, when: fg.dates.formatDate(new Date(), 'dd-mmmm hh:mm 12'), message: msg});
            fg.fantainStore.set('storedNotifications', sn);
        }

        //Notifications could appear before VM loaded, for coldstart ones. So wait for VM to load and update it
        fg.timerHandler.start('typeof fg.fVM.storedNotifications', 'undefined', false, 1000, $.noop, function () {
            fg.fVM.storedNotifications(sn.sort(fg.sortJson('when', '')));
            fg.fVM.storedNotifications.valueHasMutated();
        })

    },


    updateNotificationId: function (fantainId) {

        fg.actionStarted(fg.waitFor.upd_notification);
        var regData = {
            'regdid': fg.pushNotificationRegId,
            'model' : device.model.substr(0,50)
        };

        fg.geoloc.lat != 0 ? regData.lat = fg.geoloc.lat : '';
        fg.geoloc.lng != 0 ? regData.lng = fg.geoloc.lng : '';


        var prevPushNotificationRegId = fg.fantainStore.get('pushNotificationRegId');
        var prevPushNotificationUser = fg.fantainStore.get('pushNotificationUser');

        if (prevPushNotificationRegId == null || prevPushNotificationUser != fantainId) {

            fantainId != null ? regData.fantainid = fantainId.toString() : '';

            fg.debugMsg('About to post: ' + JSON.stringify(regData), fg.debugLevel.msgs);
            //alert('About to post: '+JSON.stringify(regData));

            $.post(fg.svcPath + "device", JSON.stringify(regData), function (result) {
                if (result.status == 'OK') {
                    fg.debugMsg('Updated Fantain server with Registration Id', fg.debugLevel.msgs);
                    fg.fantainStore.set('pushNotificationRegId', fg.pushNotificationRegId);
                    fg.fantainStore.set('pushNotificationUser', fantainId);
                    fg.actionComplete(fg.waitFor.upd_notification);
                } else {
                    fg.debugMsg('Failed to update Fantain server with Registration Id:' + result.status + ',' + result.msg, fg.debugLevel.errors);
                    fg.fantainStore.clear('pushNotificationRegId');
                    fg.fantainStore.clear('pushNotificationUser');
                    fg.actionComplete(fg.waitFor.upd_notification);
                }
            });
        } else {
            fg.actionComplete(fg.waitFor.upd_notification);
        }
    },

    inAppNotification: function (id, msg, title) {

        if (fg.isApp & !fg.inForeground) {
            window.plugin.notification.local.add({
                id: id,  // A unique id of the notification
                date: new Date(),    // This expects a date object
                message: msg,  // The message that is displayed
                title: title,  // The title of the message
                //repeat:     String,  // Either 'secondly', 'minutely', 'hourly', 'daily', 'weekly', 'monthly' or 'yearly'
                //badge:      number,  // Displays number badge to notification
                //sound:      String,  // A sound to be played
                //json:       String,  // Data to be passed through the notification
                autoCancel: true, // Setting this flag and the notification is automatically canceled when the user clicks it
                ongoing: false // Prevent clearing of notification (Android only)
            });
        } else {
            fg.fVM.inAppNotificationText = msg;
            fg.fVM.inAppNotification(true);
            setTimeout(function () {
                fg.fVM.inAppNotification(false);
            }, 3000);
        }

    }


}


//iOS
onNotificationAPN = function (e) {
    if (e.alert) {
        navigator.notification.alert(e.alert);
    }

    if (e.sound) {
        var snd = new Media(e.sound);
        snd.play();
    }

    if (e.badge) {
        fg.pushNotification.setApplicationIconBadgeNumber(successHandler, errorHandler, e.badge);
    }
}

// Android
onNotificationGCM = function (e) {
    //alert('EVENT -> RECEIVED:' + e.event);

    fg.debugMsg(JSON.stringify(e), fg.debugLevel.msgs);

    switch (e.event) {
        case 'registered':
            if (e.regid.length > 0) {
                // Your GCM push server needs to know the regID before it can push to this device
                // here is where you might want to send it the regID for later use.
                fg.debugMsg("Registered: regID = " + e.regid, fg.debugLevel.msgs);
                //alert("Registered: regID = " + e.regid);

                //Keep it for now, in fantain Login, update with either fantainId or just by itself
                fg.pushNotificationRegId = e.regid;

                //If logged in when this arrives, update our device id
                fg.debugMsg('Checking if logged in when getting notification register callback ...', fg.debugLevel.msgs);
                if (fg.is(fg.fVM.loggedIn) && fg.fVM.loggedIn()) {
                    fg.debugMsg('Logged in, so we will update notification now', fg.debugLevel.msgs);
                    fg.cb.updateNotificationId(fg.fVM.user().fantainid());
                }

            }
            break;

        case 'message':

            //Store incoming notifications as long as they aren't for page redirect
            if (!e.payload.goto) {
                fg.cb.manageNotifications(e.payload.message);
            }

            // if this flag is set, this notification happened while we were in the foreground.
            // you might want to play a sound to get the user's attention, throw up a dialog, etc.
            if (e.foreground) {
                fg.debugMsg('--INLINE NOTIFICATION--', fg.debugLevel.msgs);

                if (e.payload.goto) {
                    fg.gotoPage = e.payload.goto;
                    fg.fantainMsgOkCallback = fg.gotoPageAction;
                    fg.fantainMsgCancelCallback = '';
                    fg.fantainMsg(e.payload.message, fg.fantainMsgType.confirm);
                } else {
                    fg.fantainMsgOkCallback = $.noop;
                    fg.fantainMsg(e.payload.message, fg.fantainMsgType.alert);
                }

                // if the notification contains a soundname, play it.
                if (e.soundname) {
                    var my_media = new Media(e.soundname);
                    my_media.play();
                }
            }
            else {  // otherwise we were launched because the user touched a notification in the notification tray.
                if (e.coldstart) {
                    if (e.payload.goto) {
                        fg.gotoPage = e.payload.goto;
                        fg.coldstartaction = 'gotoPage';
                    }
                    fg.debugMsg('--COLDSTART NOTIFICATION--', fg.debugLevel.msgs);
                }
                else {
                    if (e.payload.goto) {
                        fg.gotoPage = e.payload.goto;
                        fg.fantainMsgOkCallback = fg.gotoPageAction;
                        fg.fantainMsgCancelCallback = '';
                        fg.fantainMsg(e.payload.message, fg.fantainMsgType.confirm);
                    } else {
                        fg.debugMsg('--BACKGROUND NOTIFICATION--', fg.debugLevel.msgs);
                    }
                }
            }

            break;

        case 'error':
            fg.debugMsg('ERROR -> MSG:' + e.msg, fg.debugLevel.errors);
            break;

        default:
            fg.debugMsg('EVENT -> Unknown, an event was received and we do not know what it is!', fg.debugLevel.errors);
            break;
    }
}


