/**
 * Created with JetBrains WebStorm.
 * User: aravind
 * Date: 21/8/13
 * Time: 11:47 AM
 * To change this template use File | Settings | File Templates.
 */

//All global variables & functions to be used in Fantain is defined here.

var fg = {

    //Initial status for connectedness. Transfer to KO variables later
    online: false,
    alive: false,
    connectionCheckRan: false,

    readyForBrowserBack: false, //This is required for the browser back button

    firstTime: true, //For first time processing when invoked

    sammyContext: {}, //For Sammy to keep current context

    fVM: '', //The view model bound to the html

    cbf: '?callback=?',

    gameOn: false, //Is a game currently on?

    userType: {
        fb: 'facebook',
        google: 'google',
        email: 'email',
        phone: 'phone',
        none: null
    },

    validateEmail: function (addr) {
        var emailFilter = /^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/;
        return emailFilter.test(addr);
    },

    is: function (what) {
        return !(typeof what == 'undefined');
    },

    gotoPageAction: function () {
        if (fg.gotoPage.substring(0,1) != '#')
            fg.gotoPage = '#' + fg.gotoPage;
        fg.sammyContext.redirect(fg.gotoPage);
        fg.gotoPage = '';
    },

    fantainMsgType: {
        none: 0,    //No buttons
        alert: 1,   //Only OK button
        confirm: 2  //OK or Cancel
    },

    fantainMsg: function (m, type) { //All alerts & notification messages are done through here
        document.getElementById('fantainMsgTxt').innerHTML = m;
        if (type == this.fantainMsgType.confirm) {
            document.getElementById('alertpartOKandConfirm').style.display = 'block';
            document.getElementById('alertpartOKonly').style.display = 'none';
        } else {
            document.getElementById('alertpartOKandConfirm').style.display = 'none';
            document.getElementById('alertpartOKonly').style.display = 'block';
        }
        $('#fantainMsg').fadeIn(300);
        $('.fc-msg-bg').addClass('show');
    },

    fantainMsgOkCallback: '',
    fantainMsgOkCallbackAction: function () {
        $('#fantainMsg').fadeOut(300);
        $('.fc-msg-bg').removeClass('show');
        this.fantainMsgOkCallback != '' ? this.fantainMsgOkCallback() : '';
    },
    fantainMsgCancelCallback: '',
    fantainMsgCancelCallbackAction: function () {
        $('#fantainMsg').fadeOut(300);
        $('.fc-msg-bg').removeClass('show');
        this.fantainMsgCancelCallback != '' ? this.fantainMsgCancelCallback() : '';
    },

    debugLevel: { //Constants for debug message level
        none: 0,
        errors: 1,
        timer: 2,
        warning: 3,
        msgs: 4
    },
    debugMsg: function (t, l) {

        //alert(t);

        if (this.currentDebugLevel >= l) {
            var d = new Date(), type;
            switch (l) {
                case this.debugLevel.msgs:
                    type = 'msg';
                    console.log(type + ": " + t);
                    break;
                case this.debugLevel.warning:
                    type = 'warn';
                    console.warn(type + ": " + t);
                    break;
                case this.debugLevel.timer:
                    type = 'timer';
                    console.log(type + ": " + t);
                    break;
                case this.debugLevel.errors:
                    type = 'err';
                    console.error(type + ": " + t);
                    break;
                default:
                    console.error('Code should not get here');
            }
            if (fg.env == 'dev')
                $("#fid-consoleDisplay").html("<u>" + d.toLocaleTimeString() + ":" + d.getMilliseconds() + "</u>: " + type + ":" + t + "<hr/>" + $("#fid-consoleDisplay").html());
        }
    },
    timerOption: {
        start: 0,
        end: 1
    },
    timerTable: [],
    timer: function (key, action) {
        //Replicates console.time across devices
        if (action == fg.timerOption.start) {
            var t = new Date();
            fg.timerTable.push({key: key, time: t});
        } else {
            var i = fg.timerTable.indexOfPropertyValue('key', key);
            if (i > -1) {
                fantain.analytics.timing(fg.isApp?'app':'web', key, (new Date() - fg.timerTable[i].time) )
                fg.debugMsg('-- ' + key + ' --> ' + (new Date() - fg.timerTable[i].time).toString(), fg.debugLevel.timer);
                fg.timerTable.splice(i, 1);
            }
            else {
                fg.debugMsg('-- ' + key + ' --> ' + 'Unable to find time elapsed', fg.debugLevel.timer);
            }
        }
    },
    persist: {
        set: 1,
        get: 2,
        check: 3,
        op: function (type, key, value) {
            switch (type) {
                case (fg.persist.set):

            }
        }
    },
    geoloc: {
        lat: 0,
        lng: 0
    },

    fantainStore: new Sammy.Store({name: 'fantainStore', type: 'local'}),

    //Make sure privacy policy is accepted
    termsAndConditionsAccepted: function () {
        return fg.fantainStore.get('termsAndConditionsAccepted') ? true : false;
    },

    //These are required for Cricbuzz feeds
    jsonpCallback: 'CBFeed',
    liveMatches: "http://synd.cricbuzz.com/ffant81n/scores-multi.json",
    upcomingMatches: "http://synd.cricbuzz.com/ffant81n/schedule.json", //Currently not using this
    seriesSchedule: "http://synd.cricbuzz.com/ffant81n/series-schedule.json",

    dates: {

        dateFromEpoch: function (e) {
            var d = new Date();
            d.setUTCSeconds(e);
            return d;
        },

        dateFromString: function (s) {
            //In order for it to on all browsers, convert to standards: ECMA-262 standard Section 15.9.1.15:
            var ds = s.substr(0, 4) + '-' + s.substr(5, 2) + '-' + s.substr(8, 2) + 'T' + s.substr(11, 2) + ':' + s.substr(14, 2) + ':' + s.substr(17, 2) + '.000Z';
            return new Date(ds);
        },


        CBToUTCDateTime: function (d, t, format) {
            //Stupid Cricbuzz sends 'dd mm yyyy' in some and 'mm dd yyyy' in some, so the hack
            var dp = format == 'ddmm' ? 0 : 1;
            var mp = format == 'ddmm' ? 1 : 0;
            var dtUTC = new Date();
            dtUTC.setUTCFullYear(d.split(" ", 3)[2]);
            dtUTC.setUTCMonth(Number(d.split(" ", 3)[mp]) - 1);
            dtUTC.setUTCDate(d.split(" ", 3)[dp]);
            dtUTC.setUTCHours(t.split(":", 2)[0]);
            dtUTC.setUTCMinutes(t.split(":", 2)[1]);
            dtUTC.setUTCSeconds(0);
            dtUTC.setUTCMilliseconds(0);
            return dtUTC;
        },

        MatchstartTime: function (t) {
            var tUTC = t;
            tUTC.substring(1, 4);
            return tUTC;
        },

        isToday: function (d) {
            var dc = new Date(d.getUTCFullYear(), d.getUTCMonth(), d.getUTCDate(), 0, 0, 0, 0);
            var today = new Date(new Date().getUTCFullYear(), new Date().getUTCMonth(), new Date().getUTCDate(), 0, 0, 0, 0);
            return (dc.toString() == today.toString());
        },

        isBeforeToday: function (d) {
            var dc = new Date(d.getUTCFullYear(), d.getUTCMonth(), d.getUTCDate(), 0, 0, 0, 0);
            var today = new Date(new Date().getUTCFullYear(), new Date().getUTCMonth(), new Date().getUTCDate(), 0, 0, 0, 0);
            return (dc < today && dc >= new Date(2013, 8, 25, 0, 0, 0, 0));
        },

        isAfterToday: function (d) {
            var dc = new Date(d.getUTCFullYear(), d.getUTCMonth(), d.getUTCDate(), 0, 0, 0, 0);
            var today = new Date(new Date().getUTCFullYear(), new Date().getUTCMonth(), new Date().getUTCDate(), 0, 0, 0, 0);
            return (dc > today)
        },

        getMonth: function (d) {
            var months = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'];
            return months[d.getUTCMonth()];
        },

        getDay: function (d) {
            var doftw = ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat'];
            return doftw[d.getUTCDay()];
        },

        getTimeString: function (d) {
            var h = d.getHours() > 12 ? d.getHours() - 12 : d.getHours();
            //h = h.toString().length == 1 ? '0'+ h.toString() : h.toString();
            var m = d.getMinutes();
            m = m.toString().length == 1 ? '0' + m.toString() : m.toString();
            var t = d.getHours() > 12 ? 'PM' : 'AM';
            return h + ':' + m + ' ' + t;
        },

        formatDate: function(date,mask) {

            // Convert to date and set return to the mask
            var fmtDate = new Date(date);
            date = mask.toLowerCase();

            // Replace mask tokens
            date = date.replace('w',    fg.dates.getDay(fmtDate));
            date = date.replace('dd',   fg.dates.formatDigit(fmtDate.getDate()));
            date = date.replace('mmmm', fg.dates.getMonth(fmtDate));
            date = date.replace('mm',   fg.dates.formatDigit(fmtDate.getMonth()+1));
            date = date.replace('yyyy', fmtDate.getFullYear());
            if (/12$/.test(date)) {
                date = date.replace('hh',   fg.dates.formatDigit(
                        fmtDate.getHours() > 12 ? fmtDate.getHours() - 12: fmtDate.getHours() ));
                date = date.replace(/12$/, fmtDate.getHours() >= 12 ? 'PM': 'AM' );
            } else
                date = date.replace('hh',   fg.dates.formatDigit(fmtDate.getHours()));
            date = date.replace('mi',   fg.dates.formatDigit(fmtDate.getMinutes()));
            date = date.replace('ss',   fg.dates.formatDigit(fmtDate.getSeconds()));

            return date;
        },

        formatDigit: function(digit) {
            digit += '';
            if (digit.length < 2) digit = '0' + digit;
            return digit;
        }

    },

    team: {
        getImage: function (t) {
            if (t == undefined) {
                return  'images/f_unknownTeamImage.png';
            }
            return fg.team.shortNames[t.toLowerCase()] != null ? 'images/' + fg.team.shortNames[t.toLowerCase()] + '.png' :
                'images/f_unknownTeamImage.png';
        },

        shortNames: {'india': 'IND', 'south africa': 'RSA', 'australia': 'AUS',
            'england': 'ENG', 'afghanistan': 'AFG', 'new zealand': 'NZL',
            'pakistan': 'PAK', 'west indies': 'WI', 'sri lanka': 'SL', 'usa': 'USA', 'scotland': 'SCO',
            'netherlands': 'NL', 'canada': 'CAN', 'ireland': 'IRE', 'kenya': 'KEN', 'bangladesh': 'BAN',
            'zimbabwe': 'ZIM', 'bangalore': 'BLR', 'chennai': 'CHE', 'hong kong': 'HON', 'hyderabad': 'HYD', 'kolkata': 'KOL',
            'mumbai': 'MUM', 'nepal': 'NEP', 'united arab emirates': 'UAE', 'punjab': 'PUN', 'rajasthan': 'RAJ', 'delhi': 'DEL'},

        getShortName: function (t) {
            return t == undefined ? '' : fg.team.shortNames[t.toLowerCase()] != null ? fg.team.shortNames[t.toLowerCase()] : t.substring(0, 3).toUpperCase();
        }
    },

    scoresPageRefreshTimer: null,
    playPageRefreshTimer: null,
    scorecardRefreshFreq: 30, //Refresh the scorecard every 5 seconds

    //Handle CDATA in Cricbuzz feeds

    //Since some names are long, initialize first/middle names and trunc overall length
    shortenName: function (fullname) {
        var namelength = 12;
        if (fullname.length <= namelength) return fullname;
        var shortname = fullname.split(" ");
        for (var i = 0; i < shortname.length - 1; i++) {
            shortname[i] = shortname[i].substring(0, 1);
        }
        return shortname.join(" ").length <= namelength ? shortname.join(" ") : shortname.join(" ").substring(0, namelength);
    },

    //General purpose JSON sorter
    sortJson: function (by, order) {

        order = order == null ? 1 : order;

        var key = function (x) {
            return typeof x[by] == "function" ? x[by]() : x[by];
        };

        return order ? function (a, b) {
            return a = key(a), b = key(b), a > b ? 1 : a < b ? -1 : 0;
        } : function (a, b) {
            return a = key(a), b = key(b), a < b ? 1 : a > b ? -1 : 0;
        };

    },

    pushNotification: "",
    pushNotificationRegId: "",

    //To find what we are on
    isiPhone: /iphone/img.test(navigator.userAgent),
    isiPad: /ipad/img.test(navigator.userAgent),
    isiPod: /ipod/img.test(navigator.userAgent),
    isiOS: /ip(hone|od|ad)/img.test(navigator.userAgent),
    isAndroid: /android/img.test(navigator.userAgent),
    isWebOS: /webos/img.test(navigator.userAgent),
    isBlackberry: /blackberry/img.test(navigator.userAgent),
    isTouchEnabled: ('createTouch' in document),
    isOnline: navigator.onLine,
    isStandalone: navigator.standalone,
    isiOS6: navigator.userAgent.match(/OS 6/i),
    isiOS7: navigator.userAgent.match(/OS 7/i),
    isWin: /trident/img.test(navigator.userAgent),
    isWinPhone: (/trident/img.test(navigator.userAgent) && /mobile/img.test(navigator.userAgent)),
    isIE10: navigator.userAgent.match(/msie 10/i),
    isIE11: navigator.userAgent.match(/msie 11/i),
    isWebkit: navigator.userAgent.match(/webkit/),
    isMobile: /mobile/img.test(navigator.userAgent),
    isDesktop: !(/mobile/img.test(navigator.userAgent)),
    isSafari: (!/Chrome/img.test(navigator.userAgent) && /Safari/img.test(navigator.userAgent)),
    isChrome: /chrome/i.test(navigator.userAgent),
    isFirefox: /firefox/img.test(navigator.userAgent),

    smallScreen: matchMedia(Foundation.media_queries.small).matches,
    mediumScreen: matchMedia(Foundation.media_queries.medium).matches,
    largeScreen: matchMedia(Foundation.media_queries.large).matches,
    xlargeScreen: matchMedia(Foundation.media_queries.xlarge).matches,
    xxlargeScreen: matchMedia(Foundation.media_queries.xxlarge).matches,

    //To handle 'Scores delayed by ...' string from Cricbuzz
    scoresDelayedBy: function (input) {
        var s = "Scores delayed by 15 mins ";
        var r = new RegExp(s, "i");
        if (fg.installation == 'srh') {
            return input.replace(r, '');

        } else {
            return input.replace(r, '<p class="fc-delayedScores fc-size-10 fc-text-mobcenter-desleft" id="fid-delayedScores">[' + s + ']</p>');

        }

    },

    svcTimeout: 10 * 1000, //Default is 10, changed in DevAccess file based on type of setting

    timerHandler: {

        timerHandlerTimer: [],

        start: function (variable, check, equal, dur, callback, fn) {
            fg.debugMsg('TimerHandler set for ' + variable + ' for ' + dur.toString(), fg.debugLevel.msgs);
            var e = equal ? eval(variable) == check : eval(variable) != check;
            if (e) {
                fg.debugMsg('TimerHandler exiting for ' + variable, fg.debugLevel.msgs);
                fn();
                callback();
            }
            else {
                var i = this.timerHandlerTimer.length;
                this.timerHandlerTimer[i] = setInterval(function () {
                    fg.timerHandler.repeat(variable, check, equal, callback, fn, i);
                }, dur);
            }
        },

        repeat: function (variable, check, equal, callback, fn, i) {
            var e = equal ? eval(variable) == check : eval(variable) != check;
            if (e) {
                fg.debugMsg('TimerHandler exiting for ' + variable, fg.debugLevel.msgs);
                fn();
                clearInterval(this.timerHandlerTimer[i]);
                //this.timerHandlerTimer.splice(i,1);
                callback();
            }
        }
    },

    waitFor: {
        first_time_launch:          'first-time-launch',
        load_login:                 'load-login',
        login_checks:               'login-checks',
        email_login:                'email-login',
        email_logout:               'email-logout',
        fb_login:                   'fb-login',
        fb_logout:                  'fb-logout',
        fb_setup:                   'fb-setup',
        upd_notification:           'upd-notification',
        reg_email_user:             'reg_email_user',
        load_page:                  'load-page',
        team_chosen:                'team-chosen-',
        load_new_team:              'load-new-team',
        ajax_load:                  'ajax-load-',
        get_scorecard:              'get-scorecard',
        get_schedule:               'get-schedule',
        show_schedule:              'show-schedule',
        checking_rt_events:         'checking-realtime-events',
        push_notification_reg:      'push-notification-reg',
        switch_schedule_tab:        'switch-schedule-tab',
        rt_gameon_called:           'rt-gameon-called',
        loading_fb_feed:            'loading-fb-feed',
        loading_news_feed:          'loading-news-feed',
        loading_blog_feed:          'loading-blog-feed',
        local_store:                'local-store-',
        no_action: ''
    },

    actionStarted: function (waitFor) {

        //var did = document.getElementById(waitFor);
        //$(did).addClass('pressed');

        if (fg.is(fg.fVM.waitTable)) {
            fg.timer(waitFor, fg.timerOption.start);
            fg.fVM.waitTable.indexOf(waitFor) == -1 && fg.fVM.waitTable.push(waitFor);
            fg.debugMsg('TimerSet: --> ' + waitFor + ', waiting for [' + fg.fVM.waitTable() + ']', fg.debugLevel.msgs);
        }

    },

    actionComplete: function (waitRemove) {

        //var did = document.getElementById(fg.actOn);
        //$(did).removeClass('pressed');

        if (fg.is(fg.fVM.waitTable)) {
            fg.fVM.waitTable.indexOf(waitRemove) != -1 && fg.fVM.waitTable.splice(fg.fVM.waitTable.indexOf(waitRemove), 1);
            fg.timer(waitRemove, fg.timerOption.end);
            fg.debugMsg('TimerRemoved: --> ' + waitRemove + ', waiting for [' + fg.fVM.waitTable() + ']', fg.debugLevel.msgs);
        }
    },

    //This should handle browser and device back buttons
    handleBackButton: function () {

        if (fg.closeOverlays()) {
            return true;
        } else
        //Go back to schedule page if in score page
        if (fg.is(fg.fVM.currPage) && fg.fVM.currPage() == 'fid-schedulePage' &&
            fg.fVM.scorecardUrl() != '') {
            sendEvent('tap', document.getElementById("fid-backOutOfScores"));
            return true;
        } else
        //Go back to question list if answer panel is open
        if (fg.is(fg.fVM.currPage) && fg.fVM.currPage() == 'fid-playPage' &&
            fg.fVM.currQuizId() != 0) {
            sendEvent('tap', document.getElementById("fid-playcall-answer-window-back"));
            return true;
        } else {
            return false;
        }
    },

    closeOverlays: function () {
        //If spinner is on, kill it
        fg.is(fg.fVM.waitTable) && fg.fVM.waitTable.removeAll();

        //Close msg box
        if ($('#fantainMsg').css('display') == 'block') {
            //$('#fantainMsg').fadeOut(300);
            //$('.fc-msg-bg').removeClass('show');
            return true;
        }
        //Close off canvas
        else if ($('.off-canvas-wrap.move-right').length > 0 || $('.off-canvas-wrap.move-left').length > 0) {
            sendEvent('tap', $("#fid-exit-off-canvas")[0]);
            //$('a.exit-off-canvas').trigger('tap');
            return true;
        }
        //Close modal
        else if ($('.reveal-modal.open').length > 0) {
            $('a.close-reveal-modal').trigger('click');
            return true;
        } else
            return false;
    },

    checkConnectivity: function () {
        requirejs(['fantainDevAccess'], function (deviceAccess) {
            var devAccess = new deviceAccess();
            fg.isApp ? devAccess.setDevDetails() : '';
            devAccess.fantainUp();
        });
    },

    //Lifted from zRSSFeed - Credit to them for this code
    rssFeed: function (url, options, fn) {

        // Set plugin defaults
        var defaults = {
            limit: 10,
            offset: 1,
            header: true,
            date: true,
            dateformat: 'datetime',
            content: true,
            snippet: true,
            media: true,
            showerror: true,
            errormsg: '',
            key: null,
            ssl: false,
            sort: '',
            sortasc: true,
            historical: false
        };

        var options = $.extend(defaults, options);

        var s = '';

        // Check for SSL protocol
        if (options.ssl) s = 's';

        // Check for valid url
        if (url == null) return false;

        // Add start offset to feed length
        if (options.offset > 0) options.offset -= 1;
        options.limit += options.offset;

        // Create Google Feed API address
        var api = "http" + s + "://ajax.googleapis.com/ajax/services/feed/load?v=1.0&callback=?&q=" + encodeURIComponent(url);
        api += "&num=" + options.limit;
        if (options.historical) api += "&scoring=h";
        if (options.key != null) api += "&key=" + options.key;
        api += "&output=json_xml"

        // Send request
        $.getJSON(api, function (data) {

            // Check for error
            if (data.responseStatus == 200) {
                fn('success', data.responseData.feed);
            } else {
                fn('error', data.responseDetails);
            }
        });

    },

    //Removes all <img * src='' *> tags and returns the content & images array
    removeImg: function (c) {
        var ip = /<img.*?src="(.*?)".*?>/gi;
        var prevIndex = 0, snippet = '', s = '', images = [];
        while (ip.test(c)) {
            var ips = /<img.*?src="(.*?)".*?>/i;
            var ipl = /<img.*?src="(.*?)"/i;
            snippet = c.substring(prevIndex, ip.lastIndex);
            images.push(ipl.exec(snippet)[1])
            s += snippet.replace(ips, '');
            prevIndex = ip.lastIndex;
        }
        s += c.substring(prevIndex);
        images.unshift(s);
        return (images);
    },

    replaceHref: function (c, idtag) {
        var op = '^o^', opp=/\^o\^/g, cl = '^c^', clp = /\^c\^/g, noHtml = /(<([^>]+)>)/gi;
        var hp = /<a href="(.*?)">(.*?)<\/a>/gi;
        var prevIndex = 0, snippet = '', s = '';
        while (hp.test(c)) {
            var hps = /<a href=.*?>(.*?)<\/a>/i;
            var hpl = /href="(.*?)"/i;
            snippet = c.substring(prevIndex, hp.lastIndex);
            s += snippet.replace(hps, op+'span id="' + idtag + hpl.exec(snippet)[1]+'"' + cl + op + 'b' + cl +
                hps.exec(snippet)[1] + op + '/b' + cl + op + '/span' + cl);
            prevIndex = hp.lastIndex;
        }
        s += c.substring(prevIndex);
        s = s.replace(noHtml, '');
        s = s.replace(opp, '<');
        s = s.replace(clp, '>');
        s = s.replace(/\&nbsp\;/gi, '');
        s = s.replace(/\s{2,}/g,' ');
        return s.trim();
    },

    showExternalLink: function (link) {

        fg.debugMsg('Now starting inapp browser for' + link, fg.debugLevel.msgs);
        var extWindow = window.open(link, '_blank', 'location=yes');
        fg.debugMsg('After starting inapp browser for' + link, fg.debugLevel.msgs);

    },

    lapsedTime: function(date) {

        // Get current date and format date parameter
        var todayDate = new Date();
        var pastDate = new Date(date);

        // Get lasped time in seconds
        var lapsedTime = Math.round((todayDate.getTime() - pastDate.getTime())/1000)

        // Return lasped time in seconds, minutes, hours, days and weeks
        if (lapsedTime < 60) {
            return '< 1 min';
        } else if (lapsedTime < (60*60)) {
            var t = Math.round(lapsedTime / 60) - 1;
            var u = 'min';
        } else if (lapsedTime < (24*60*60)) {
            var t = Math.round(lapsedTime / 3600) - 1;
            var u = 'hour';
        } else if (lapsedTime < (7*24*60*60)) {
            var t = Math.round(lapsedTime / 86400) - 1;
            var u = 'day';
        } else {
            var t = Math.round(lapsedTime / 604800) - 1;
            var u = 'week';
        }

        // Check for plural units
        if (t > 1) u += 's';
        return t + ' ' + u;
    },


    dummy: 'So we can put a comma at the end of everything before this!'
}

/************** Global Error Trap *************************/
//window.onerror = function (errEvent, errObj) {
//
//    var msg = fg.is(errObj) ?  'errObj not obtained for error' :
//        (typeof errObj == 'string') ? errObj : errObj.message;
//    var ev = fg.is(errEvent) ?  'errEvent not obtained for error' :
//        (typeof errEvent == 'string') ? errEvent : errEvent.type;
//
//    fg.debugMsg(msg, fg.debugLevel.errors);
//    fg.debugMsg(ev, fg.debugLevel.errors);
//
//    //fg.fantainMsgOkCallback = window.location.reload.bind(window.location);
//    if (fg.is(fg.fVM.waitTable)) fg.fVM.waitTable.removeAll();
//    fg.gotoPage = '#home';
//    fg.fantainMsgOkCallback = fg.gotoPageAction;
//    fg.fantainMsg('An unexpected error has occurred and logged. We apologize for the inconvenience. Press OK to go to Home Page', fg.fantainMsgType.alert);
//    return true;
//}

//Lets define some object extensions that we need
String.prototype.capitalize = function () {
    return this.charAt(0).toUpperCase() + this.slice(1);
}

//Some Array prototypes since we work with them a lot

Array.prototype.countOccurrence = function (w) {
    var count = 0;
    for (var i = 0; i <= this.length; i++) {
        if (typeof this[i] === 'function') {
            if (typeof this[i]() == 'string') {
                this[i]().match(new RegExp(w)) ? count++ : '';
            } else {
                this[i]() == w ? count++ : '';
            }
        } else {
            if (typeof this[i] == 'string') {
                this[i].match(new RegExp(w)) ? count++ : '';
            } else {
                this[i] == w ? count++ : '';
            }
        }
    }
    return count;
}

Array.prototype.filter = function (by, value) {
    var r = [];
    for (var i = 0; i < this.length; i++) {
        if (typeof this[i] === 'function') {
            typeof this[i]()[by] === 'function' ?
                    this[i]()[by]() == value ? r.push(this[i]()) : '' :
                    this[i]()[by] == value ? r.push(this[i]()) : '';
        } else {
            typeof this[i][by] === 'function' ?
                    this[i][by]() == value ? r.push(this[i]) : '' :
                    this[i][by] == value ? r.push(this[i]) : '';
        }
    }
    return r;
}

Array.prototype.countBy = function (by, value) {
    var n = this.filter(by, value);
    return n.length;
}

Array.prototype.indexOfPropertyValue = function (prop, value) {
    var i = this.length;
    while (i--) {
        if (typeof this[i] === 'object') {
            if (typeof this[i][prop] === 'function') {
                if (this[i][prop]() == value) break;
            } else {
                if (this[i][prop] == value) break;
            }
        } else if (typeof this[i] === 'function') {
            if (typeof this[i]()[prop] === 'function') {
                if (this[i]()[prop]() == value) break;
            } else {
                if (this[i]()[prop] == value) break;
            }
        }
    }
    return i;
}
