/**
 * Found out after too much time loss that jQuery & Hammer have some problems
 * playing together. At least that is my theory. So here goes without jQuery.
 * Have a helper function that identifies the parentNode link for any clicks for
 * action.
 */



(function (document) {

    fg.debugMsg('Loaded fantainInteract', fg.debugLevel.msgs);

    /** Using Hammer */
    fg.interact = {};
    fg.interact.INT = Hammer;
    fg.interact.touchStart = " touchStart ";
    fg.interact.tap = " tap ";
    fg.interact.hold = " longTap ";
    fg.interact.swipeRight = " dragright ";
    fg.interact.swipeLeft = " dragleft ";
    fg.interact.swipeUp = " dragup ";
    fg.interact.swipeDown = " dragdown ";


    // This is to handle the double event generated by some mobile browsers - 300ms
    // difference - *2 is to allow for execution speed
    var prevEventTimeStamp = 0;
    var secondEvent = function (ev) {
        // fg.debugMsg('in secondEvent checker, ev type is ' + ev.type + ' at ' + ev.timeStamp, fg.debugLevel.msgs);
        if ((ev.timeStamp - prevEventTimeStamp) < 600) {
            prevEventTimeStamp = ev.timeStamp;
//        fg.debugMsg('Second event, so this will not fire', fg.debugLevel.msgs);
            return true;
        } else {
            prevEventTimeStamp = ev.timeStamp;
            return false;
        }
    }

    //Click can be in inner elements. Return the outermost id for the clicked element
    var clickOn = function (el) {
        if (el.id != '')
            return el.id;
        while (el.id == '') {
            el = el.parentNode;
            if (el.id != '')
                return el.id;
        }
        return null;
    }


    var bodyElement = document.getElementsByTagName('body')[0];
    fg.interact.INT(bodyElement).on(fg.interact.tap + fg.interact.hold +
        fg.interact.swipeDown + fg.interact.swipeUp +
        fg.interact.swipeRight + fg.interact.swipeLeft, function (event) {



        //fg.debugMsg('Click registered!', fg.debugLevel.msgs);

        event.stopPropagation();
        event.preventDefault();
        if (event.gesture) event.gesture.stopDetect();

        if (secondEvent(event)) return; //Ignore if it is a second click in mobile browsers
        if (fg.fVM.waitTable().length > 0) return; //Ignore if something is already happening
        $('.off-canvas-wrap').removeClass('move-right');

        var cl = clickOn(event.target);

        fg.debugMsg('Got click on '+ cl, fg.debugLevel.msgs);

        cl != undefined && fantain.analytics.sendevent(["user", event.type, cl.replace(/^fid-/,""), 1]);

        switch (cl) {

        /********** General **********************************************************************/
            case undefined:
                break;

        /********** Header Events *****************************************************************/
            case 'fid-main-nav-btn':
                $('.off-canvas-wrap').toggleClass('move-right');
                break;
            case 'homeMenu':
                fg.actionStarted(fg.waitFor.load_page + "#home");
                fg.sammyContext.redirect('#home');
                //fantain.analytics.ui('button', 'home');
                break;
            case 'fid-touchLogin':
                //fantain.analytics.ui('button', 'login');
                if (!fg.fVM.alive()) {
                    fg.fantainMsgOkCallback = '';
                    fg.fantainMsg('You can login only when connected to Fantain!', fg.fantainMsgType.alert);
                }
                else if (fg.fVM.loggedIn()) {
                    fg.actionStarted(fg.waitFor.load_page + "#profile");
                    fg.sammyContext.redirect(fg.fVM.user().profileLink());
                    //fantain.analytics.page(fg.fVM.user().profileLink());
                } else {
                    fg.actionStarted(fg.waitFor.load_page + "#login");
                    fg.sammyContext.redirect("#login");
                }
                break;
            //This is for ratings
            case 'rating-' + cl.slice("rating-".length):
                var z = cl.substring("rating-".length);
                var x = Number(z.substring(0, z.indexOf('-'))) - 1;
                var y = Number(z.substring(z.indexOf('-') + 1));
                for (var i = 1; i <= y; i++) {
                    fg.fVM.rating()[x][i] = true;
                }
                for (i = y + 1; i <= 5; i++) {
                    fg.fVM.rating()[x][i] = false;
                }
                fg.fVM.rating.valueHasMutated();
                break;
            case 'feedbackClear':
                //fantain.analytics.ui('feedback', 'clear');
                for (i = 0; i <= 3; i++) {
                    for (var j = 1; j <= 5; j++) {
                        fg.fVM.rating()[i][j] = false;
                    }
                }
                fg.fVM.rating.valueHasMutated();
                fg.fVM.feedbackText('');
                break;
            case 'feedbackClose':
                $('a.close-reveal-modal').trigger('click');
                break;
            case 'feedbackSubmit':
                //fantain.analytics.ui('feedback', 'submit');
                //Post to a service here
                if (fg.fVM.rating()[0].countOccurrence(true) > 0 ||
                    fg.fVM.rating()[1].countOccurrence(true) > 0 ||
                    fg.fVM.rating()[2].countOccurrence(true) > 0 ||
                    fg.fVM.rating()[3].countOccurrence(true) > 0 ||
                    (fg.fVM.feedbackText() !== '' && fg.fVM.feedbackText() !== null)) {
                    var rData = {};
                    for (i = 0; i <= 3; i++) {
                        rData['q' + (i + 1).toString() + 'lbl'] = fg.fVM.rating()[i][0];
                        rData['q' + (i + 1).toString() + 'ans'] = fg.fVM.rating()[i].countOccurrence(true);
                        //rData[fg.fVM.rating()[i][0]] = fg.fVM.rating()[i].countOccurrence(true);
                    }
                    rData.text = fg.fVM.feedbackText();
                    fg.fVM.loggedIn() ? rData.fantainid = fg.fVM.user().fantainId() : '';
                    fg.debugMsg('Submitting Feedback: ' + JSON.stringify(rData), fg.debugLevel.msgs);
                    $.post(fg.svcPath + "feedback", JSON.stringify(rData), function (result) {
                        $('a.close-reveal-modal').trigger('click');
                        if (result.status == 'OK') {
                            fg.fantainMsgOkCallback = '';
                            fg.fantainMsg('Thank you for your feedback');
                        } else {
                            fg.fantainMsgOkCallback = '';
                            fg.fantainMsg('Error - ' + result.msg + '. Can you kindly try again?');
                        }
                    });
                }
                ;

                //Feedback clearing the values
                //fantain.analytics.ui('feedback', 'clear');
                for (i = 0; i <= 3; i++) {
                    for (var j = 1; j <= 5; j++) {
                        fg.fVM.rating()[i][j] = false;
                    }
                }
                fg.fVM.rating.valueHasMutated();
                fg.fVM.feedbackText('');

                break;

        /********** Footer Events *********************************************************************/
            case 'adLink-' + cl.slice("adLink-".length):
                //fantain.analytics.ui('advertisement', 'click');
                fg.debugMsg('Clicked on link:' + cl.substring("adLink-".length), fg.debugLevel.msgs);
                break;

        /********** Choose friends Events *****************************************************************/
            case 'fid-friendSelect-' + cl.slice("fid-friendSelect-".length):
                fg.fVM.chooseOrUnchooseFriends(cl.slice("fid-friendSelect-".length));
                break;

        /********** Home Page Events *****************************************************************/
//            case 'fid-followLink':
//                fg.fantainMsgOkCallback = '';
//                fg.fantainMsg('Coming soon', fg.fantainMsgType.alert);
//                break;
            case 'fid-connectLink':
                fg.fantainMsgOkCallback = $.noop;
                fg.fantainMsg('Coming soon', fg.fantainMsgType.alert);
                break;
            case 'fid-leaderboardLink':
                if (fg.installation == 'srh') {
                    fg.fantainMsgOkCallback = $.noop;
                    fg.fantainMsg('Coming soon!', fg.fantainMsgType.alert);
                    break;
                }
                if (!fg.fVM.online()) {
                    fg.fantainMsgOkCallback = $.noop;
                    fg.fantainMsg('You need to be online for accessing this', fg.fantainMsgType.alert);
                    break;
                } 
                if (!fg.fVM.loggedIn()) {
                    fg.fantainMsgOkCallback = fg.fVM.goToLoginPage;
                    fg.fantainMsgCancelCallback = $.noop;
                    fg.fantainMsg('You should login to see the Leaderboard. Login now?', fg.fantainMsgType.confirm);
                    break;
                }
            case 'fid-shopLink':
            case 'fid-followLink':
            case 'fid-playLink':
                if (!fg.fVM.online()) {
                    fg.fantainMsgOkCallback = $.noop;
                    fg.fantainMsg('You need to be online for accessing this', fg.fantainMsgType.alert);
                    break;
                }
            case 'fid-fanzoneLink':
            case 'fid-blogLink':
            case 'fid-newsLink':
            case 'fid-consoleLink':
            case 'fid-scheduleLink':
            case 'fid-loginLink':
                fg.actionStarted(fg.waitFor.load_page + "#" + cl.substring(4, cl.length - 4));
                fg.sammyContext.redirect("#" + cl.substring(4, cl.length - 4));
                break;
            case 'fid-profileLink':
                fg.actionStarted(fg.waitFor.load_page + "#profile");
                fg.sammyContext.redirect("#" + cl.substring(4, cl.length - 4) + "/" + fg.fVM.user().fantainId());
                break;
            case 'fid-aboutLink':
                fg.fVM.launchAboutUs();
                break;
            case 'fid-aboutFantainLink':
                fg.fVM.launchAboutFantain();
                break;
            case 'fid-privacypolicyLink':
                fg.fVM.launchPrivacypolicy();
                break;

        /********** Launch Page Events *****************************************************************/
            case 'fid-delNotification-' + cl.slice("fid-delNotification-".length):
                fg.fVM.storedNotifications.remove(function (item) {
                    return item.id == cl.slice("fid-delNotification-".length)
                });
                fg.fVM.storedNotifications.valueHasMutated();
                fg.fantainStore.set('storedNotifications', fg.fVM.storedNotifications());
                break;
            case 'fid-remindMe':
                fg.fVM.reminderSet() == 'Not Set' || fg.fVM.reminderSet() == null ? fg.fVM.setupReminder() : '';
                break;
            case 'fid-refreshGameon':
                fg.fVM.refreshGameOn();
                break;

        /************* Play page events ********************************************************************/
            case 'matchScore':
                fg.fVM.scorecardUrl($("#" + cl).attr("url"));
                fg.sammyContext.redirect("#scores");
                //fantain.analytics.page("Scores");
                //fantain.analytics.fan("score", "view");
                break;
            case 'fid-select-team-btn':
                if (!fg.fVM.loggedIn()) {
                    fg.fantainMsgOkCallback = fg.fVM.goToLoginPage;
                    fg.fantainMsgCancelCallback = '';
                    fg.fantainMsg('You should be logged in for this. Login now?', fg.fantainMsgType.confirm);
                }
                break;
            case 'fid-touchTeam1':
                if (fg.is(fg.fVM.matchInfo())) {
                    if (!fg.fVM.loggedIn()) {
                        fg.fantainMsgOkCallback = fg.fVM.goToLoginPage;
                        fg.fantainMsgCancelCallback = '';
                        fg.fantainMsg('You should be logged in for this. Login now?', fg.fantainMsgType.confirm);
                        break;
                    }
                    fg.actionStarted(fg.waitFor.team_chosen + "1");
                    fg.fVM.playForTeam(fg.fVM.matchInfo().team1());
                    //fantain.analytics.fan("choose team", fg.fVM.matchInfo().team1);
                    fg.appHeight();
                    fg.actionComplete(fg.waitFor.team_chosen + "1");
                }
                break;
            case 'fid-touchTeam2':
                if (fg.is(fg.fVM.matchInfo())) {
                    if (!fg.fVM.loggedIn()) {
                        fg.fantainMsgOkCallback = fg.fVM.goToLoginPage;
                        fg.fantainMsgCancelCallback = '';
                        fg.fantainMsg('You should be logged in for this. Login now?', fg.fantainMsgType.confirm);
                        break;
                    }
                    fg.actionStarted(fg.waitFor.team_chosen + "2");
                    fg.fVM.playForTeam(fg.fVM.matchInfo().team2());
                    //fantain.analytics.fan("choose team", fg.fVM.matchInfo().team2);
                    fg.appHeight();
                    fg.actionComplete(fg.waitFor.team_chosen + "2");
                }
                break;

            // Quiz answer window open for mobile
            case 'quiz-' + cl.slice("quiz-".length):
                if (fg.fVM.currQuizId() != cl.slice("quiz-".length) && event.type == fg.interact.tap.trim()) {
                    fg.fVM.showQuestion(cl.slice("quiz-".length));
                }
                break;

            // Quiz answer window close for mobile
            case 'fid-playcall-answer-window-back':
                fg.fVM.closeQuestion();
                break;
            /*case 'fid-playcall-answer-window':
             if(event.type == fg.interact.swipeRight.trim()) {
             $('.fc-msg-bg').removeClass('show');
             fg.fVM.currQuizId(0);
             }
             break;*/

            case 'quizChoice-' + cl.slice("quizChoice-".length):
                if (!fg.smallScreen) {
                    fg.fVM.currQuizId($("#" + clickOn(event.target)).attr("quiz"));
                }
                if (fg.smallScreen && event.type == fg.interact.swipeRight.trim()) {
                    fg.fVM.closeQuestion();
                }
                if (event.type == fg.interact.tap.trim()) {
                    fg.fVM.choiceClicked(Number(cl.substring("quizChoice-".length)));
                }
                //fantain.analytics.quiz(cl.substring("questionsPane-".length), qaction, qtype, complexity);
                break;


            case 'fid-choose-friends':
                if (fg.fVM.user().userType() != fg.userType.fb) {
                    fg.fantainMsgOkCallback = fg.fVM.goToLoginPage;
                    fg.fantainMsg('Social play only when logged in with Facebook. Go to login page?', fg.fantainMsgType.confirm);
                    //fantain.analytics.fan("friends", "view");
                } else if (fg.fVM.playingFor() == 0) {
                    fg.fantainMsgOkCallback = '';
                    fg.fantainMsg('Select a team to play for before adding your friends!', fg.fantainMsgType.alert);
                    //fantain.analytics.fan("friends", "view");
                }
                else {
                    $('.off-canvas-wrap').toggleClass('move-left');
                }
                break;
            case 'fid-exit-off-canvas':
                $('.off-canvas-wrap').removeClass('move-left');
                $('.off-canvas-wrap').removeClass('move-right');
                break;
            case 'fid-shareMatchScoreOnFB':
                if (!fg.fVM.loggedIn() || fg.fVM.user().userType() != fg.userType.fb) {
                    fg.fantainMsgOkCallback = fg.fVM.goToLoginPage;
                    fg.fantainMsgCancelCallback = '';
                    fg.fantainMsg('You should login thru Facebook to share your score with friends. Login now?', fg.fantainMsgType.confirm);
                } else if (fg.fVM.playingFor() == 0) {
                    fg.fantainMsgOkCallback = '';
                    fg.fantainMsg('Select a team to play for before sharing your match score with friends!', fg.fantainMsgType.alert);
                } else {
                    fg.fVM.postScoreOnFB('match', fg.fVM.playcallFriends().filter('fantainId', fg.fVM.user().fantainId())[0].score());
                    fantain.analytics.facebook("share", "score");
                }
                break;

            case 'fid-selectFriends-' + cl.slice('fid-selectFriends-'.length):
                if (fg.fVM.playcallFriends().countBy('chosenFriend', true) >= 5 && !fg.fVM.playcallFriends()[fg.fVM.playcallFriends().indexOfPropertyValue('fantainId', cl.slice('fid-selectFriends-'.length))].chosenFriend()) {
                    fg.fantainMsgOkCallback = '';
                    fg.fantainMsg("You can view only up to 4 friends' score in the Playcall screen. Go to Leaderboard to view others scores", fg.fantainMsgType.alert);
                }
                break;

        /********** Login Page Events ******************************************************/
            case 'fbLoginButton':
                if (!fg.fVM.online() || !fg.fVM.alive()) {
                    fg.fantainMsgOkCallback = '';
                    fg.fantainMsg('You need to be online & connected to Fantain for logging in', fg.fantainMsgType.alert);
                } else {
                    fg.fVM.goToFBLogin();
                    fantain.analytics.facebook("login", "facebook");
                }
                break;
            case 'emailLoginButton':
                if (!fg.fVM.online() || !fg.fVM.alive()) {
                    fg.fantainMsgOkCallback = '';
                    fg.fantainMsg('You need to be online & connected to Fantain for logging in', fg.fantainMsgType.alert);
                } else {
                    fg.fVM.goToEmailLogin();
                    //fantain.analytics.ui("login", "email");
                }
                break;
            case 'emailRegisterButton':
                fg.fVM.goToEmailRegister();
                //fantain.analytics.ui("register", "email");
                break;

        /************ Profile page events ***********************************************/
            case 'logout':
                fg.fantainMsgOkCallback = fg.fVM.logout;
                fg.fantainMsg('Are you sure you want to logout?', fg.fantainMsgType.confirm);
                //fantain.analytics.ui("button", "logout");
                break;
            /*
             * if (fg.fantainMsg('Are you sure you want to logout?',
             * fg.fantainMsgType.confirm)) { fg.ga('event', ["Touch",
             * "Logout", fg.fVM.user().fantainId(), 2]); fg.fVM.logout(); }
             */
            case 'fid-favPlayersClose':
            case 'fid-favTeamsClose':
            case 'fid-favVenuesClose':
                $('a.close-reveal-modal').trigger('click');
                fg.fVM.saveFavourites();
                break;
            case 'favPlayerOff-' + cl.slice("favPlayerOff-".length):
                fg.fVM.favourites().players.push(cl.slice("favPlayerOff-".length));
                $.unique(fg.fVM.favourites().players);
                fg.fVM.favourites.valueHasMutated();
                break;
            case 'favPlayerOn-' + cl.slice("favPlayerOn-".length):
                fg.fVM.favourites().players = $.grep(fg.fVM.favourites().players, function (v) {
                    return v != cl.slice("favPlayerOn-".length);
                })
                fg.fVM.favourites.valueHasMutated();
                break;
            /*            case 'favTeamOff-' + cl.slice("favTeamOff-".length):
             fg.fVM.favourites().teams.push(cl.slice("favTeamOff-".length));
             $.unique(fg.fVM.favourites().teams);
             fg.fVM.favourites.valueHasMutated();
             break;
             case 'favTeamOn-' + cl.slice("favTeamOn-".length):
             fg.fVM.favourites().teams =  $.grep(fg.fVM.favourites().teams, function(v) { return v != cl.slice("favTeamOn-".length); })
             fg.fVM.favourites.valueHasMutated();
             break;*/
            case 'favVenueOff-' + cl.slice("favVenueOff-".length):
                fg.fVM.favourites().venues.push(cl.slice("favVenueOff-".length));
                $.unique(fg.fVM.favourites().venues);
                fg.fVM.favourites.valueHasMutated();
                break;
            case 'favVenueOn-' + cl.slice("favVenueOn-".length):
                fg.fVM.favourites().venues = $.grep(fg.fVM.favourites().venues, function (v) {
                    return v != cl.slice("favVenueOn-".length);
                })
                fg.fVM.favourites.valueHasMutated();
                break;
            case 'fid-shareTotalScoreOnFB':
                fg.fVM.postScoreOnFB('total', fg.fVM.user().score());
                fantain.analytics.facebook("share", "Total Score");
                break;
            case 'fid-inviteFBFriends':
                fg.fVM.inviteFBFriends();
                fantain.analytics.facebook("invite", "friends");
                break;

        /******** Schedule page events ***************************************************/
            case 'refreshSchedule':
                fg.fVM.liveMatches([]);
                fg.fVM.allSeries([]);
                fg.fVM.buildSchedulePage();
                break;

            case 'liveScorecard-' + cl.slice("liveScorecard-".length):
                    if ([fg.interact.tap.trim(), fg.interact.hold.trim()].indexOf(event.type) > -1) {
                        if (fg.fVM.online()) {
                            fg.fVM.scorecardUrl(cl.substring("liveScorecard-".length));
                            fg.fVM.getScores();
                            //fantain.analytics.page("Score");
                            fg.appHeight();
                        } else {
                            fg.fantainMsgOkCallback = $.noop;
                            fg.fantainMsg('Scores currently available only when online', fg.fantainMsgType.alert);
                        }
                    }

                    if ([fg.interact.swipeDown.trim()].indexOf(event.type) > -1) {
                        if($('#fid-schedulePage').scrollTop() == 0) {

                            if (!fg.fVM.online()) {
                                fg.fantainMsgOkCallback = $.noop;
                                fg.fantainMsg('Not connected, try after reconnecting', fg.fantainMsgType.alert);
                            } else {

                                fg.fVM.pullToRefreshSchedule(true);
                                fg.actionStarted(fg.waitFor.get_schedule);
                                fg.fVM.updateLiveMatches($.noop);

                                fg.loadingLiveSchedules = setTimeout(function () {
                                    if (!fg.stillLoadingLiveSchedules) {
                                        fg.fVM.pullToRefreshSchedule(false);
                                    }
                                    fg.loadingLiveSchedules = 0;
                                }, 2000);

                            }

                        }
                    }
                break;

            case 'resultsScorecard-' + cl.slice("resultsScorecard-".length):
                if ([fg.interact.tap.trim(), fg.interact.hold.trim()].indexOf(event.type) > -1) {
                    if (fg.fVM.online()) {
                        fg.fVM.scorecardUrl(cl.substring("resultsScorecard-".length));
                        fg.fVM.getScores();
                        //fantain.analytics.page("Score");
                        fg.appHeight();
                    } else {
                        fg.fantainMsgOkCallback = $.noop;
                        fg.fantainMsg('Scores currently available only when online', fg.fantainMsgType.alert);
                    }
                }

                if ([fg.interact.swipeDown.trim()].indexOf(event.type) > -1) {
                    if($('#fid-schedulePage').scrollTop() == 0) {

                        if (!fg.fVM.online()) {
                            fg.fantainMsgOkCallback = $.noop;
                            fg.fantainMsg('Not connected, try after reconnecting', fg.fantainMsgType.alert);
                        } else {
                            fg.fVM.pullToRefreshSchedule(true);
                            fg.actionStarted(fg.waitFor.get_schedule);
                            fg.fVM.updateAllSeries();

                            fg.loadingResultsSchedule = setTimeout(function () {
                                if (!fg.stillLoadingResultsSchedule) {
                                    fg.fVM.pullToRefreshSchedule(false);
                                }
                                fg.loadingResultsSchedule = 0;
                            }, 2000);
                        }

                    }
                }
                break;

            case 'pull-refresh-' + cl.slice("pull-refresh-".length):
                if ([fg.interact.swipeDown.trim()].indexOf(event.type) > -1) {
                    if($('#fid-schedulePage').scrollTop() == 0) {
                        if (!fg.fVM.online()) {
                            fg.fantainMsgOkCallback = $.noop;
                            fg.fantainMsg('Not connected, try after reconnecting', fg.fantainMsgType.alert);
                        } else {
                            fg.fVM.pullToRefreshSchedule(true);

                            fg.actionStarted(fg.waitFor.get_schedule);
                            fg.fVM.updateAllSeries();
                        }
                    }
                }
                break;

            case 'fid-noLiveScores-' + cl.slice("fid-noLiveScores-".length):
                if ([fg.interact.tap.trim(), fg.interact.hold.trim()].indexOf(event.type) > -1) {
                    fg.fantainMsgOkCallback = $.noop;
                    fg.fantainMsg('Scorecard for all completed matches ...', fg.fantainMsgType.alert);
                } else if ([fg.interact.swipeDown.trim()].indexOf(event.type) > -1) {
                    if($('.fc-main-con').scrollTop() == 0) {
                        if (!fg.fVM.online()) {
                            fg.fantainMsgOkCallback = $.noop;
                            fg.fantainMsg('Not connected, try after reconnecting', fg.fantainMsgType.alert);
                        } else {
                            fg.fVM.pullToRefreshSchedule(true);

                            fg.actionStarted(fg.waitFor.get_schedule);
                            fg.fVM.updateLiveMatches($.noop);
                        }
                    }
                }
                break;

            case 'liveSchedule':
                fg.actionStarted(fg.waitFor.switch_schedule_tab);

                fg.fVM.currentSchedule(fg.fVM.liveScheduleText());
                fg.fVM.scorecardUrl('');
                fg.appHeight();

                fg.fVM.loadSchedules();

                fg.actionComplete(fg.waitFor.switch_schedule_tab);
                break;
            case 'resultsSchedule':
                fg.actionStarted(fg.waitFor.switch_schedule_tab);

                fg.fVM.currentSchedule(fg.fVM.resultsScheduleText());
                fg.fVM.scorecardUrl('');
                fg.appHeight();

                fg.fVM.loadSchedules();
                fg.fVM.clearScheduleFilters();
                fg.fVM.showCorrectSchedule();

                fg.actionComplete(fg.waitFor.switch_schedule_tab);
                break;
            case 'upcomingSchedule':
                fg.actionStarted(fg.waitFor.switch_schedule_tab);

                fg.fVM.currentSchedule(fg.fVM.upcomingScheduleText());
                fg.fVM.scorecardUrl('');
                fg.appHeight();

                fg.fVM.loadSchedules();
                fg.fVM.clearScheduleFilters();
                fg.fVM.showCorrectSchedule();

                fg.actionComplete(fg.waitFor.switch_schedule_tab);
                break;
            case 'scheduleTeamSelected':
            case 'scheduleSeriesSelected':
            case 'scheduleVenueSelected':
                fg.fVM.showCorrectSchedule();
                break;
            case 'fid-sortSchedule':
                fg.fVM.allSeries.sort(fg.sortJson('startUTC', fg.fVM.scheduleSorter()));
                fg.fVM.scheduleSorter(!fg.fVM.scheduleSorter());
                fg.fVM.showCorrectSchedule(cl);
                break;
            case 'fid-delayedScores':
                fg.cb.inAppNotification('delayedScores', 'Scores delayed due to local legal restrictions', 'Scores Delayed');
                break;


        /********** Scores page events ***************************************************/
            case 'innings-' + cl.slice("innings-".length):
                fg.fVM.activeInnings(Number(cl.substring("innings-".length)));
                break;
            case 'fid-backOutOfScores':
                setTimeout(function () {
                    fg.fVM.scorecardUrl('');
                    fg.appHeight();
                }, .5*1000);
                break;

        /*********** Leaderboard page events *********************************************/
            case fg.fVM.currentMatchText():
                if (fg.fVM.gameOn()) {
                    fg.fVM.leaderboard('');
                    fg.fVM.currentLB(fg.fVM.currentMatchText());
                    fg.fVM.getLeaderboard();
                } else {
                    fg.fantainMsgOkCallback = '';
                    fg.fantainMsg('Game Leaderboard only when a Playcall match is in progress', fg.fantainMsgType.alert);
                }
                break;
            case fg.fVM.lifetimeScoreText():
                fg.fVM.leaderboard('');
                fg.fVM.currentLB(fg.fVM.lifetimeScoreText());
                fg.fVM.getLeaderboard();
                break;
            case fg.fVM.lbMyFriendsText():
                if (fg.fVM.user().userType() == fg.userType.email) {
                    fg.fantainMsgOkCallback = fg.fVM.goToLoginPage;
                    fg.fantainMsgCancelCallback = '';
                    fg.fantainMsg('You should login thru Facebook to play with friends. Login now?', fg.fantainMsgType.confirm);
                } else {
                    fg.fVM.leaderboard('');
                    fg.fVM.currentLBFor(fg.fVM.lbMyFriendsText());
                    fg.fVM.getLeaderboard();
                    //fg.ga("event", [ "Touch", "Show Overall Leaderboard", "event only", 2 ]);
                }
                break;
            case fg.fVM.lbAll():
                fg.fVM.currentLBFor(fg.fVM.lbAll());
                fg.fVM.getLeaderboard();
                //fg.ga("event", [ "Touch", "Show Overall Leaderboard", "event only", 2 ]);
                break;
            //Handle the sorts
            case 'sortName':
                fg.fVM.nameSort = !fg.fVM.nameSort;
                fg.fVM.leaderboard.sort(fg.sortJson("firstname", fg.fVM.nameSort));
                break;
            case 'sortPoints':
                fg.fVM.pointsSort = !fg.fVM.pointsSort;
                fg.fVM.leaderboard.sort(fg.sortJson("score", fg.fVM.pointsSort));
                break;
            case 'sortRank':
                fg.fVM.rankSort = !fg.fVM.rankSort;
                fg.fVM.leaderboard.sort(fg.sortJson("rank", fg.fVM.rankSort));
                break;

        /********* Facebook page events *************************************************/
            case 'fid-fblink-' + cl.slice("fid-fblink-".length):
                var link = cl.slice("fid-fblink-".length);
                fg.showExternalLink(link);
                break;
            case 'fid-newslink-' + cl.slice("fid-newslink-".length):
                var link = cl.slice("fid-newslink-".length);
                fg.showExternalLink(link);
                break;
            case 'fid-bloglink-' + cl.slice("fid-bloglink-".length):
                var link = cl.slice("fid-bloglink-".length);
                fg.showExternalLink(link);
                break;

        /********* News page events *************************************************/
            case 'fid-news-item-' + cl.slice("fid-news-item-".length):
                if ([fg.interact.swipeDown.trim()].indexOf(event.type) > -1) {
                    if($('#fid-newsPage').scrollTop() == 0) {

                        if (!fg.fVM.online()) {
                            fg.fantainMsgOkCallback = $.noop;
                            fg.fantainMsg('Not connected, try after reconnecting', fg.fantainMsgType.alert);
                        } else {
                            fg.fVM.pullToRefreshNews(true);

                            // Waiting
                            fg.fVM.loadNewsFeed();
                            fg.loadingNewsFeed = setTimeout(function () {
                                if (!fg.stillLoadingNewsFeed) {
                                    fg.fVM.pullToRefreshNews(false);
                                }
                                fg.loadingNewsFeed = 0;
                            }, 2000);
                        }
                    }
                }
                break;

        /********* Blog page events *************************************************/
            case 'fid-blog-item-' + cl.slice("fid-blog-item-".length):
                if ([fg.interact.swipeDown.trim()].indexOf(event.type) > -1) {
                    if($('#fid-blogPage').scrollTop() == 0) {
                        if (!fg.fVM.online()) {
                            fg.fantainMsgOkCallback = $.noop;
                            fg.fantainMsg('Not connected, try after reconnecting', fg.fantainMsgType.alert);
                        } else {
                            fg.fVM.pullToRefreshBlog(true);
                            fg.fVM.loadBlogFeed();

                            fg.loadingBlogFeed = setTimeout(function () {
                                if (!fg.stillLoadingBlogFeed) {
                                    fg.fVM.pullToRefreshBlog(false);
                                }
                                fg.loadingBlogFeed = 0;
                            }, 2000);
                        }
                    }
                }
                break;

        /********* Facebook page events *************************************************/
            case 'fid-facebook-item-' + cl.slice("fid-facebook-item-".length):
                if ([fg.interact.swipeDown.trim()].indexOf(event.type) > -1) {
                    if($('#fid-fanzonePage').scrollTop() == 0) {

                        if (!fg.fVM.online()) {
                            fg.fantainMsgOkCallback = $.noop;
                            fg.fantainMsg('Not connected, try after reconnecting', fg.fantainMsgType.alert);
                        } else {
                            fg.fVM.pullToRefreshFacebook(true);
                            fg.fVM.loadFacebookFeed();


                            fg.loadingFacebookFeed = setTimeout(function () {
                                if (!fg.stillLoadingFacebookFeed) {
                                    fg.fVM.pullToRefreshFacebook(false);
                                }
                                fg.loadingFacebookFeed = 0;
                            }, 2000);
                        }
                    }
                }
                break;

        /********* Connect page events *************************************************/
            case 'chat-' + cl.slice("chat-".length):
                fg.fVM.currentlyChattingWith(cl.substring("chat-".length));
                //fg.ga("event", [ "Touch", "Chat Session", "event only", 2 ]);
                break;
            case 'backToChatList':
                fg.fVM.currentlyChattingWith('');
                break;
            case 'msgSend':
                fg.fVM.chatMsgSend();
                //fg.ga("event", [ "Touch", "Send Chat Message", "event only", 2 ]);
                break;

            /*******************************************************************************/
            default:
        }
    });

    document.addEventListener('keydown', function(event) {
        if (event.keyCode == 13) {
            if(event.target.id == 'fid-loginEmail-Input'){
                sendEvent('tap',document.getElementById('emailLoginButton'));
            }
            else if(event.target.id == 'fid-lastName-Registration'){
                sendEvent('tap',document.getElementById('emailRegisterButton'));
            }
        }
    }, true);





    fg.debugMsg('Done with interact, now to load foundation', fg.debugLevel.msgs);
    $(document).foundation();
    fg.debugMsg('Foundation loaded', fg.debugLevel.msgs);


})(document);

/* When using Knockout, dropdown selection event is only fired using
 * subscribe. In order for that to come into the fantainInteract.js model,
 * we will create an event on the selected element programatically and send
 * it to fantainInteract for it to be processed like the rest of the events.
 * The subscribe action is done in fantainRoutes.js right after the VM is set*/
function sendEvent(ev, element) {

    var event; // The custom event that will be created

    if (document.createEvent) {
        event = document.createEvent("HTMLEvents");
        event.initEvent(ev, true, true);
    } else {
        event = document.createEventObject();
        event.eventType = ev;
    }

    event.eventName = ev;

    if (document.createEvent) {
        element.dispatchEvent(event);
    } else {
        element.fireEvent("on" + event.eventType, event);
    }
}


// Resize event
$(window).resize(function () {
    fg.appHeight();
});

