/* ------------------------------------------------------------------------------------------------- */
//These are login functions. 1. Check login status 2. Login to FB 3. Login to Email
//For 1, global variable fg.fVM.loggedIn() will be updated. Any check will be against that variable only.
// If any event occurs to change login status, then call this
// 

/*(function (factory) {
 if (fg.app) {
 define(['cordova', 'cdv-plugin-fb-connect', 'facebook-js-sdk'], factory);
 } else {
 define([], factory);
 }
 }*/
//define(function () {

define(function () {

    return function fantainLogin() {

        var self = this;

        fg.debugMsg('Loaded fantain login util', fg.debugLevel.msgs);

        var getLoginStatusTimer, loginTimer, apiTimer;
        var getLoginStatusTimedout = false, loginTimedout = false, apiTimedout = false;
        self.initFBTimeout = function (timeoutFor) {
            switch (timeoutFor) {
                case 'getLoginStatus':
                    getLoginStatusTimedout = false;
                    getLoginStatusTimer = setTimeout(function () {
                        getLoginStatusTimedout = true;
                        fg.actionComplete(fg.waitFor.fb_login);
                        fg.fantainMsgOkCallback = self.logoutOfFB;
                        fg.fantainMsg('FB Get Login Status taking too long to respond, please try later', fg.fantainMsgType.alert);
                    }, fg.svcTimeout);
                    break;
                case 'login':
                    loginTimedout = false;
                    loginTimer = setTimeout(function () {
                        loginTimedout = true;
                        fg.actionComplete(fg.waitFor.fb_login);
                        fg.fantainMsgOkCallback = self.logoutOfFB;
                        fg.fantainMsg('FB Login taking too long to respond, please try later', fg.fantainMsgType.alert);
                    }, fg.svcTimeout);
                    break;
                case 'api':
                    apiTimedout = false;
                    apiTimer = setTimeout(function () {
                        apiTimedout = true;
                        fg.actionComplete(fg.waitFor.fb_login);
                        fg.fantainMsgOkCallback = self.logoutOfFB;
                        fg.fantainMsg('FB API taking too long to respond, please try later', fg.fantainMsgType.alert);
                    }, fg.svcTimeout);
                    break;
                default:
                //Shouldn't get here
            }
        }

        self.setupFB = function (callback, callbackParam) {
            fg.debugMsg('Ready to initialize FB ...', fg.debugLevel.msgs);

            fg.actionStarted(fg.waitFor.fb_setup);

            requirejs(['cdv-fb', 'facebook'], function () {
                if (typeof FB == 'undefined') {
                    fg.debugMsg('FB variable does not exist. Check that you have included the Facebook JS SDK file', fg.debugLevel.errors);
                } else
                    try {
                        if (fg.isApp)
                            FB.init({ appId: fg.FBAppId, nativeInterface: CDV.FB, useCachedDialogs: false });
                        else
                            FB.init({
                                appId: fg.FBAppId, // App ID
                                channelUrl: 'channel.html', // Channel File
                                status: true, // check login status
                                cookie: true, // enable cookies to allow the server to access the session
                                xfbml: true,  // parse XFBML
                                oauth: true   // using the new oauth2 standard
                            });
                        fg.actionComplete(fg.waitFor.fb_setup);
                        callback(callbackParam);
                    } catch (e) {
                        fg.debugMsg('Unable to initialize Facebook plugins, error ' + e, fg.debugLevel.errors);
                        fg.actionComplete(fg.waitFor.fb_setup);
                        self.notLoggedIn();
                    }
            });
        }

        self.firstTimeCheck = function () {

            fg.actionStarted(fg.waitFor.login_checks);

            var loggedInUser = {
                fantainId: '',
                userType: '',
                fbId: '',
                email: ''
            };

            loggedInUser.fantainId = fg.fantainStore.get('fantainId');
            loggedInUser.userType = fg.fantainStore.get('userType');
            fg.debugMsg('Got fantainId ' + loggedInUser.fantainId + ' of type ' + loggedInUser.userType, fg.debugLevel.msgs);
            if (loggedInUser.userType == fg.userType.fb) {
                self.setupFB(self.checkInFBUser, '');
            }
            else if (loggedInUser.userType == fg.userType.email) {
                loggedInUser.email = fg.fantainStore.get('email');
                self.checkInEmailUser(loggedInUser);
            } else {
                //No previous logins
                self.notLoggedIn();
                //fg.actionComplete();
            }

            fg.actionComplete(fg.waitFor.login_checks);

        }

        self.checkInFBUser = function () {
            try {
                fg.actionStarted(fg.waitFor.fb_login);
                fg.debugMsg('In checkInFBUser, about to launch getLoginStatus', fg.debugLevel.msgs);
                self.initFBTimeout('getLoginStatus');
                FB.getLoginStatus(function (fbResponse) {
                    if (!getLoginStatusTimedout) {
                        clearTimeout(getLoginStatusTimer);
                        fg.debugMsg('Facebook status is ' + fbResponse.status, fg.debugLevel.msgs);
                        if (fbResponse.status == 'connected') {
                            self.initFBTimeout('api');
                            FB.api('/me?access_token=' + fbResponse.authResponse.accessToken, {fields: 'id, first_name, last_name'}, function (fbApiResponse) {
                                if (!loginTimedout) {
                                    clearTimeout(apiTimer);
                                    fg.debugMsg('api response is ' + JSON.stringify(fbApiResponse), fg.debugLevel.msgs);

                                    $.ajaxSetup({async: false});
                                    $.getJSON(fg.svcPath + 'login/f/' + fbApiResponse.id + fg.cbf, function (fantainResponse) {
                                        if (fantainResponse.status == 'OK') {
                                            self.setupFBParameters(fbApiResponse, fantainResponse);
                                            self.getFBFriends();
                                            fg.actionComplete(fg.waitFor.fb_login);
                                            return true;
                                        } else {
                                            //Trouble.
                                            fg.fantainMsg('Some login error occurred. Please try and relogin', fg.fantainMsgType.alert);
                                            self.notLoggedIn();
                                            self.clearFantainStore();
                                            fg.actionComplete(fg.waitFor.fb_login);
                                            return false;
                                        }
                                    });
                                } else {
                                    //Timedout, timer function will handle the exit
                                    return false;
                                }

                                $.ajaxSetup({async: true});
                            })
                        } else {
                            //Clear local storage if any
                            self.notLoggedIn();
                            self.clearFantainStore();
                            fg.actionComplete(fg.waitFor.fb_login);
                            return false;
                        }
                    } else {
                        //Timedout, timer function will handle the exit
                        return false;
                    }
                }, true);
                //Code shouldn't get here
                return false;
            } catch (e) {
                fg.debugMsg('Some error occurred in CheckInFBLogin ' + e.message, fg.debugLevel.errors);
                self.clearFantainStore();
                self.notLoggedIn();
                fg.actionComplete(fg.waitFor.fb_login);
                return false;
            }

        }

        self.checkInEmailUser = function (loggedInUser) {
            fg.actionStarted(fg.waitFor.email_login);
            $.ajaxSetup({async: false});
            $.getJSON(fg.svcPath + 'login/' + loggedInUser.fantainId + fg.cbf, function (fantainResponse) {
                if (fantainResponse.status == 'OK') {
                    self.setupEmailParameters(fantainResponse, loggedInUser.email, true);
                    self.addUserToFriends();
                    fg.actionComplete(fg.waitFor.email_login);
                } else {
                    //Trouble. Integrity issues between stored id & fantain db. Clear everything & ask for relogin
                    fg.fantainMsg('Some login error occurred. Please try and relogin', fg.fantainMsgType.alert);
                    self.notLoggedIn();
                    self.clearFantainStore();
                    fg.actionComplete(fg.waitFor.email_login);
                    return false;
                }
            });
            $.ajaxSetup({async: true});
        }

        self.notLoggedIn = function () {
            fg.fVM.loggedIn(false);
            fg.fVM.user().userType(fg.userType.none);
            fg.fVM.user().fantainId('');
            fg.fVM.user().firstName('login');
            fg.fVM.user().lastName('');
            fg.fVM.user().joinDate('');
            fg.fVM.user().lastLogin('');
            fg.fVM.user().loginImg('images/notLoggedIn.jpg');
            fg.fVM.user().loginAlt('Not logged in');
            fg.fVM.user().profileLink('#login');

            fg.fVM.user().score(0);
            fg.fVM.user().friends([]);
            fg.fVM.user().online(false);

            //fg.fVM.chosenFriends([]);
            fg.fVM.playcallFriends([]);
            fg.fVM.quizArray.destroyAll();
            fg.fVM.currQuizId('');
            fg.fVM.playingFor(0);

            //fg.actionComplete();

            fg.isApp ? fg.cb.updateNotificationId(null) : '';

        }

        self.clearFantainStore = function () {
            fg.fantainStore.clear('fantainId');
            fg.fantainStore.clear('fbId');
            fg.fantainStore.clear('userType');
            fg.fantainStore.clear('email');
        }

        self.loginToFB = function (callback) {
            self.setupFB(self.loginToFBContinue, callback);
        }

        self.loginToFBContinue = function (callback) {
            fg.actionStarted(fg.waitFor.fb_login);
            try {
                fg.debugMsg('In loginToFBContinue, about to launch login', fg.debugLevel.msgs);
                //self.initFBTimeout('login');
                FB.login(function (fbResponse) {

                        //if (!loginTimedout) {
                            if (fbResponse.status == 'connected') {
                                //clearTimeout(loginTimer);
                                fg.debugMsg('fb logged in', fg.debugLevel.msgs);

                                self.initFBTimeout('api');
                                FB.api('/me?access_token=' + fbResponse.authResponse.accessToken, {fields: 'id, first_name, last_name, email'}, function (fbApiResponse) {
                                    if (!apiTimedout) {
                                        clearTimeout(apiTimer);
                                        fg.debugMsg('FB.api /me executed, fbApiResponse obtained', fg.debugLevel.msgs);
                                        $.ajaxSetup({async: false});
                                        $.getJSON(fg.svcPath + 'login/f/' + fbApiResponse.id + fg.cbf, function (fantainResponse) {
                                            fg.debugMsg('login/f executed, fantainResponse obtained, status is ' + fantainResponse.status, fg.debugLevel.msgs);

                                            if (fantainResponse.status == "OK") {
                                                self.setupFBParameters(fbApiResponse, fantainResponse);
                                                self.getFBFriends();
                                                fg.actionComplete(fg.waitFor.fb_login);
                                                callback();
                                            } else {
                                                var registerData = {
                                                    "firstname": fbApiResponse.first_name,
                                                    "lastname": fbApiResponse.last_name,
                                                    "email": fbApiResponse.email || ""  };

                                                $.ajaxSetup({async: false});
                                                var posting = $.post(fg.svcPath + 'register/f/' + fbApiResponse.id, JSON.stringify(registerData));
                                                posting.done(function (fantainResponse) {
                                                    //$.post(fg.svcPath + 'register/f/' + fbApiResponse.id + fg.cbf , JSON.stringify(registerData), function (fantainResponse) {
                                                    fg.debugMsg('register/f executed, status is ' + fantainResponse.status, fg.debugLevel.msgs);
                                                    if (fantainResponse.status == "OK") {
                                                        self.setupFBParameters(fbApiResponse, fantainResponse);
                                                        self.getFBFriends();
                                                        fg.actionComplete(fg.waitFor.fb_login);
                                                        callback();
                                                    } else {
                                                        fg.fantainMsg('Something went wrong in registering you as a Fantain user ... ' + fantainResponse.msg, fg.fantainMsgType.alert);
                                                        self.notLoggedIn();
                                                        self.clearFantainStore();
                                                        fg.actionComplete(fg.waitFor.fb_login);
                                                        callback();
                                                    }
                                                });
                                                $.ajaxSetup({async: true});
                                            }
                                        });
                                        $.ajaxSetup({async: true});
                                    } else {
                                        //Timedout, timer function will handle the exit
                                        return false;
                                    }
                                })
                            } else {
                                fg.debugMsg('Unable to log into Facebook', fg.debugLevel.msgs);
                                self.notLoggedIn();
                                self.clearFantainStore();
                                fg.actionComplete(fg.waitFor.fb_login);
                                callback();
                            }
//                        } else {
//                            //Timedout, timer function will handle the exit
//                            return false;
//                        }
                    },
                    { scope: "email" }
                )
            } catch (e) {
                fg.debugMsg('Some error occurred in login function: ' + e.message, fg.debugLevel.msgs);
                self.clearFantainStore();
                self.notLoggedIn();
                fg.actionComplete(fg.waitFor.fb_login);
                return false;
            }
        }

        self.setupFBParameters = function (fbApiResponse, fantainResponse) {
            fg.debugMsg('In setupFBParameters, with ' + fbApiResponse.id + ' and ' + fantainResponse.fantainid, fg.debugLevel.msgs);

            //FB related params are set here
            fg.fVM.user().userType(fg.userType.fb);
            fg.fVM.user().fbId(fbApiResponse.id);
            fg.fVM.user().firstName(fbApiResponse.first_name);
            fg.fVM.user().lastName(fbApiResponse.last_name);
            fg.fVM.user().loginImg('https://graph.facebook.com/' + fg.fVM.user().fbId() + '/picture');

            fg.fantainStore.set('userType', fg.userType.fb);
            fg.fantainStore.set('fbId', fbApiResponse.id);

            //Common params are set through this function
            self.setupUserParameters(fantainResponse, true);

        }

        self.setupEmailParameters = function (fantainResponse, emailAddr, remember) {

            fg.fVM.user().userType(fg.userType.email);
            fg.fVM.user().firstName(fantainResponse.firstname);
            fg.fVM.user().lastName(fantainResponse.lastname);
            fg.fVM.user().loginImg("images/e_emailUserSilhouette.png");


            fg.fVM.loggedIn(true);

            if (remember) {
                fg.fantainStore.set('userType', fg.userType.email);
                fg.fantainStore.set('email', emailAddr);
            }

            //Common params are set through this function
            self.setupUserParameters(fantainResponse, remember);

        }

        self.setupUserParameters = function (fantainResponse, remember) {

            fg.fVM.user().fantainId(fantainResponse.fantainid);
            fg.fVM.user().joinDate(fantainResponse.joined);
            fg.fVM.user().lastLogin(fantainResponse.lastlogin);
            fg.fVM.user().loginAlt(fg.fVM.user().name);
            fg.fVM.user().profileLink("#profile/" + fantainResponse.fantainid);

            fg.fVM.user().online(fantainResponse.online);
            fg.fVM.user().score(fantainResponse.score);
            fg.fVM.user().friends(fantainResponse.friends);

            fg.fVM.favourites().teams = fantainResponse.teams == undefined ? [] : fantainResponse.teams;
            fg.fVM.favourites().players = fantainResponse.players == undefined ? [] : fantainResponse.players;
            fg.fVM.favourites().venues = fantainResponse.venues == undefined ? [] : fantainResponse.venues;
            fg.fVM.favourites.valueHasMutated();

            if (remember) {
                fg.fantainStore.set('fantainId', fantainResponse.fantainid);
                fg.fantainStore.set('lastLogin', new Date());
            }

            fg.isApp ? fg.cb.updateNotificationId(fantainResponse.fantainid) : '';

            fg.fVM.loggedIn(true);

        }

        self.loginToEmail = function (emailAddr, remember, callback) {
            fg.actionStarted(fg.waitFor.email_login);
            fg.debugMsg('Logging in with ' + emailAddr + ' and remember is ' + (remember ? 'true' : 'false'), fg.debugLevel.msgs);

            $.getJSON(fg.svcPath + 'login/e/' + emailAddr + fg.cbf, function (fantainResponse) {
                if (fantainResponse.status == "OK") {
                    self.setupEmailParameters(fantainResponse, emailAddr, remember);
                    self.addUserToFriends();
                    fg.actionComplete(fg.waitFor.email_login);
                    callback();
                    $('a.close-reveal-modal').trigger('click');
                } else {
                    $('#connect-with-email-register').foundation('reveal', 'open');
                    fg.actionComplete(fg.waitFor.email_login);
                    fg.fVM.showRegisterPage(true);
                }
            });
        }

        self.registerEmailUser = function (emailAddr, remember, firstName, lastName, callback) {
            fg.actionStarted(fg.waitFor.reg_email_user);
            var registerData = {
                'firstname': firstName,
                'lastname': lastName,
                'email': emailAddr
            };
            $.ajaxSetup({async: false});
            var posting = $.post(fg.svcPath + 'register/e/' + emailAddr, JSON.stringify(registerData));
            posting.done(function (fantainResponse) {
                //$.post(fg.svcPath + 'register/e/' + emailAddr + fg.cbf , JSON.stringify(registerData), function (fantainResponse) {
                if (fantainResponse.status == "OK") {
                    self.setupEmailParameters(fantainResponse, emailAddr, remember);
                    self.addUserToFriends();
                    fg.actionComplete(fg.waitFor.reg_email_user);
                    callback();
                } else {
                    fg.fantainMsg('Something went wrong in registering you as a Fantain user ... ' + fantainResponse.msg, fg.fantainMsgType.alert);
                    self.notLoggedIn();
                    self.clearFantainStore();
                    fg.actionComplete(fg.waitFor.reg_email_user);
                    callback();
                }
            });
            $.ajaxSetup({async: true});
        }

        self.logoutOfFB = function (callback) {
            fg.debugMsg('Logging user out of FB', fg.debugLevel.msgs);
            fg.actionStarted(fg.waitFor.fb_logout);
            //setupFB();
            FB.logout(function (response) {
                fg.debugMsg('Got response from FB: ' + response, fg.debugLevel.msgs);
            });
            self.notLoggedIn();
            self.clearFantainStore();
            fg.actionComplete(fg.waitFor.fb_logout);
            callback && callback();
        }

        self.logoutOfEmail = function (callback) {
            fg.debugMsg('Logging user out of Email', fg.debugLevel.msgs);
            fg.actionStarted(fg.waitFor.email_logout);
            self.notLoggedIn();
            self.clearFantainStore();
            fg.actionComplete(fg.waitFor.email_logout);
            callback & callback();
        }

        self.getFBFriends = function () {

            fg.debugMsg('About to get friends from FB', fg.debugLevel.msgs);
            FB.api('/me/friends', { fields: 'id, name, picture, installed' }, function (response) {
                if (response.error) {
                    fg.fantainMsg('Error getting FB friends :' + JSON.stringify(response.error), fg.fantainMsgType.alert);
                } else {
                    fg.debugMsg('Got friends from FB', fg.debugLevel.msgs);
                    //fg.fVM.playcallFriends([]); // fg.fVM.otherFriends([]);
                    var reqData = {'facebook': []};
                    for (var i = 0; i < response.data.length; i++) {
                        response.data[i].installed ? reqData.facebook.push(response.data[i].id) : '1';
                    }
                    var pFBFriends = $.post(fg.svcPath + 'map/', JSON.stringify(reqData));
                    fg.debugMsg('Now trying to get playcall friends from Fantain', fg.debugLevel.msgs);
                    pFBFriends.done(function (mapResponse) {
                        fg.debugMsg('Got response from Fantain for friends', fg.debugLevel.msgs);

                        if (Modernizr.webworkers) {
                            var workerUpdateFriendsArray = new Worker('js/f/fantainUtils-workerUpdateFriendsArray.js');
                            workerUpdateFriendsArray.addEventListener('message', function (e) {
                                var temp = ko.mapping.fromJS(e.data);
                                fg.fVM.playcallFriends(temp.data());
                                fg.debugMsg('Now ready to add me as friend', fg.debugLevel.msgs);
                                self.addUserToFriends();
                            }, false);
                            workerUpdateFriendsArray.postMessage({response: response, mapResponse: mapResponse});
                        } else {
                            for (var i = 0; i < response.data.length; i++) {
                                response.data[i].chosenFriend = false;
                                response.data[i].score = 0;
                                if (response.data[i].installed && mapResponse.facebook[response.data[i].id] != null) {
                                    //response.data[i].visible = ko.observable(true);
                                    response.data[i].fantainId = mapResponse.facebook[response.data[i].id];
                                    response.data[i].playcallFriend = true;
                                } else {
                                    //response.data[i].visible = ko.observable(true);
                                    response.data[i].fantainId = 0;
                                    response.data[i].playcallFriend = false;
                                }
                                fg.fVM.playcallFriends.push(ko.mapping.fromJS(response.data[i]));
                            }
                            fg.debugMsg('Now ready to add me as friend', fg.debugLevel.msgs);
                            self.addUserToFriends();
                        }
                    });

                }
            });
        }

        self.addUserToFriends = function () {

            if (fg.fVM.playcallFriends().indexOfPropertyValue('fantainId', fg.fVM.user().fantainId()) == -1) {
                fg.fVM.playcallFriends().push({
                    id: ko.observable((typeof fg.fVM.user().fbId != 'undefined') ? fg.fVM.user().fbId() : ''),
                    installed: ko.observable(true),
                    name: ko.observable(fg.fVM.user().firstName() + ' ' + fg.fVM.user().lastName()),
                    picture: {
                        data: {
                            url: ko.observable(fg.fVM.user().loginImg())
                        }
                    },
                    score: ko.observable(0),
                    fantainId: ko.observable(fg.fVM.user().fantainId().toString()),
                    playcallFriend: ko.observable(false),
                    chosenFriend: ko.observable(true)
                });
                fg.fVM.playcallFriends.valueHasMutated();
            }
        }

    }
});
