define(function () {

    return function checkGameOn() {

        var self = this;

        fg.debugMsg('Loaded fantainUtils-svc', fg.debugLevel.msgs);

        self.svcCall = function (params) {

            try {

                if (params.wait) fg.actionStarted(fg.waitFor.ajax_load + params.url);

                //Set values so the success & error handlers can access them
                self.wait = params.wait;
                self.url = params.url;
                self.successCallback = params.successCallback;
                self.errorCallback = params.errorCallback;
                self.returnNode = params.returnNode;
                self.passThrough = params.passThrough;
                self.fantainSvc = params.fantainSvc;

                $.ajax({
                    url: params.url,
                    type: params.type,
                    data: JSON.stringify(params.postData),
                    dataType: params.dataType ? params.dataType : 'json',
                    jsonpCallback: params.jsonpCallback ? params.jsonpCallback : '',
                    timeout: fg.svcTimeout,
                    success: self.svcSuccess,
                    error: self.svcError
                });
            } catch (e) {
                self.svcError(null, e.message, e);
            }

        };

        //Value add - Handle errors & send back only right values
         self.svcSuccess = function (data, textStatus, jqXHR) {
            if (self.wait) fg.actionComplete(fg.waitFor.ajax_load + self.url);
            if (self.fantainSvc && data.status != 'OK') {
                fg.debugMsg('Got status ' + data.status + ' from ' + this.url + '. Attention needed!', fg.debugLevel.errors);
                self.errorCallback({msg: data.status}, self.passThrough);
            } else {
                self.successCallback(self.fantainSvc ? data[self.returnNode] : data, self.passThrough);
            }
        };

        self.svcError = function (jqXHR, textStatus, errorThrown) {
            if (self.wait) fg.actionComplete(fg.waitFor.ajax_load + self.url);
            var retval = {msg: textStatus};
            if (textStatus == 'timeout') retval.timeout = true; else retval.timeout = false;
            self.errorCallback(retval, self.passThrough);
        };

    }
});