(function (namespace, $) {

    $(document).ready(function() {
        //All connectors dont mess or bother understanding below this line... 
        //Friend events 
        fantain.fq.fansocket.on("c_add_fr",  fantain.fq.api.friend_added);
        fantain.fq.fansocket.on("c_rm_fr",   fantain.fq.api.friend_removed);
        fantain.fq.fansocket.on("c_frscore", namespace.friendscoreupdate);
        fantain.fq.fansocket.on("c_u_addfr", fantain.fq.api.added_as_a_friend);
        fantain.fq.fansocket.on("c_u_rmfr", fantain.fq.api.removed_as_a_friend);

        //Quiz events
        fantain.fq.quizsocket.on("c_answer", namespace.quizanswered);
        fantain.fq.quizsocket.on("c_qzload", namespace.loadquiz);
        fantain.fq.fansocket.on("c_qz_upd", namespace.updatequiz);
        fantain.fq.fansocket.on("c_qz_new", namespace.newquiz);
        fantain.fq.fansocket.on("c_qstats", namespace.quizstats);

        //News and advertising
        fantain.fq.fansocket.on("c_news", fantain.fq.api.news_update);

        //My Events
        fantain.fq.fansocket.on("c_score", namespace.scoreupdate);
        fantain.fq.fansocket.on("c_gameon", namespace.gamestarted);
        fantain.fq.fansocket.on("c_stream",  fantain.fq.api.msg_stream);
        fantain.fq.fansocket.on("c_mclosed", fantain.fq.api.match_closed);

        //If something goes wrong... all of them fire the same error handler
        fantain.fq.fansocket.on("c_error", fantain.fq.api.handle_error);
        fantain.fq.quizsocket.on("c_error", fantain.fq.api.handle_error);
    });

    //Event processors/helpers
    //
    namespace.quizstats = function(qstatsdata) {
        var quizid = fantain.fq.UserQuiz.UpdateStats(qstatsdata);
        fantain.fq.api.quiz_stats(quizid);

    }
    //Quiz events
    namespace.loadquiz=function(qzdata) {
        fantain.fq.quiz = [];
        for (var i=0;i<qzdata.length;i++) {
            var quizob = fantain.fq.UserQuiz.Create(qzdata[i]);
            fantain.fq.quiz.push(quizob);
        }
        fantain.fq.quiz.sort(function (l, r) { return parseInt(r.quizid) - parseInt(l.quizid); });
        fantain.fq.api.quiz_loaded();
    }

    namespace.updatequiz=function(qzdata) {
        var arrayid = fantain.fq.UserQuiz.Update(qzdata);
        fantain.fq.api.quiz_updated(arrayid);
    }

    namespace.newquiz=function(qzdata) {
        var quizarrayid = -1;
        var quizobj = fantain.fq.UserQuiz.Create(qzdata);
        fantain.fq.quiz.push(quizobj);
        fantain.fq.quiz.sort(function (l, r) { return parseInt(r.quizid) - parseInt(l.quizid); });

        for (var i=0;i<fantain.fq.quiz.length;i++) {
            if ( fantain.fq.quiz[i].quizid == qzdata.q.id )
            {
                quizarrayid = i;
                break;
            }
        }
        fantain.fq.api.quiz_add(quizarrayid);
    }

    //Friend Events
    namespace.loadplayingfriends = function(myfriends) {
        var eachfr = null;
        fantain.fq.playingfriends = [];
        for (eachfr in myfriends) {
            var frobj = fantain.fq.PlayingFriend.Create(eachfr);
            fantain.fq.playingfriends.push(frobj);            
        }
        fantain.fq.api.friends_playing_loaded();
    }

    namespace.loadallfriends = function(myfriends) {
        var eachfr = null;
        fantain.fq.allfriends = [];
        for (eachfr in myfriends) {
            var frobj = fantain.fq.MyFriend.Create(eachfr);
            fantain.fq.allfriends.push(frobj);            
        }
        fantain.fq.api.friends_all_loaded();
    }

    //My Events handlers

    namespace.gamestarted = function(playerdata) {
        fantain.fq.me = fantain.fq.Player.Create(playerdata);
        fantain.fq.api.game_started();
    }

    namespace.scoreupdate = function(quizid, lifetime, match, quiz) {
        fantain.fq.Player.UpdateScore(lifetime);
        fantain.fq.UserQuiz.UpdateScore(quizid, quiz);
        fantain.fq.api.my_score_updated(quizid, lifetime, match, quiz);
    }
    
    namespace.quizanswered = function(quizid, respid) {
        var quizarrayid = fantain.fq.UserQuiz.UpdateAnswer(quizid, respid);
        fantain.fq.api.quiz_answered(quizarrayid, respid);
    }

    namespace.friendscoreupdate = function(fantainid, quizid, lifetime, match, quiz) {
        fantain.fq.api.friend_score_updated( fantainid, lifetime, match);
    }

})(fantain.fq, jQuery);
