(function (namespace, appglobal, analytics, $) {

    //Friend Events

    namespace.friend_added = function(fr_id) {
        fantain.analytics.sendevent(["platform", "response", "friend_add", fr_id])
        appglobal.debugMsg("friend added : " + fr_id, appglobal.debugLevel.msgs);
    }

    namespace.friend_removed = function(fr_id) {
        fantain.analytics.sendevent(["platform", "response", "friend_remove", fr_id])
        appglobal.debugMsg("friend removed: " + fr_id, appglobal.debugLevel.msgs);
    }

    //Playcall Quiz Events

    namespace.quiz_answered = function(quizid, respid) {
        //This function is called when a quiz response has been registered by the serer
        fantain.analytics.sendevent(["platform", "response", "quiz_answer", 1])
        appglobal.debugMsg("Quiz response received: " + respid, appglobal.debugLevel.msgs);
        appglobal.fVM.answeredQuiz(fantain.fq.quiz[quizid]);
    }

    namespace.quiz_loaded= function() {
        //this method is called to notify all the quizzes are loaded
        fantain.analytics.sendevent(["platform", "response", "quiz_load", 1])
        appglobal.debugMsg("quiz loaded : " + fantain.fq.quiz.length, appglobal.debugLevel.msgs);
        //alert("quiz loaded : " + fantain.fq.quiz.length);
        appglobal.fVM.loadQuiz(fantain.fq.quiz);
    }
    
    namespace.quiz_updated = function(quizid) {
        fantain.analytics.sendevent(["platform", "event", "quiz_update", quizid])
        appglobal.debugMsg("quiz updated " + quizid, appglobal.debugLevel.msgs);
        //alert("quiz updated " + quizid);
        appglobal.fVM.updateQuiz(fantain.fq.quiz[quizid]);
    }

    namespace.quiz_add = function(quizid) {
        fantain.analytics.sendevent(["platform", "event", "quiz_added", quizid])
        appglobal.debugMsg("quiz added : " + quizid, appglobal.debugLevel.msgs);
        //alert("quiz added " + quizid);
        appglobal.fVM.addQuiz(fantain.fq.quiz[quizid]);
    }

    namespace.quiz_stats = function(quizid) {
        fantain.analytics.sendevent(["platform", "event", "quiz_stats", quizid])
        fg.debugMsg("quiz stats updated " + quizid, fg.debugLevel.msgs);
        //alert("quiz stats for " + quizid);
        appglobal.fVM.updateQuiz(fantain.fq.quiz[quizid]);
    }

    //Fan and friends Events
    namespace.game_started = function() {
        appglobal.debugMsg("login successful...", appglobal.debugLevel.msgs);
        //testGameOnHarness()
    }

    namespace.msg_stream = function(from, msg) {
    //This is the general message that you will get when someone messages you
    //or some system message happens
        fantain.analytics.sendevent(["platform", "event", "msg", 1])
        appglobal.debugMsg("received stream msg : " + msg + " from: "+ from, appglobal.debugLevel.msgs);
        appglobal.fVM.chatMsgRecd(from, msg);
    }
    
    namespace.my_score_updated = function(quizid, lifetime, match, quiz) {
        fantain.analytics.sendevent(["platform", "event", "score_update", lifetime])
        appglobal.debugMsg("My Lifetime Score Updated: " + lifetime, appglobal.debugLevel.msgs);
        appglobal.debugMsg("My match Score Updated: " + match, appglobal.debugLevel.msgs);
        appglobal.debugMsg("My Quiz Score Updated: "+ quiz + " for " +quizid, appglobal.debugLevel.msgs);
        appglobal.fVM.updateMyScore(quizid, lifetime, match, quiz);
    }

    namespace.friend_score_updated = function (fantainid, lifetime, match) {
        fantain.analytics.sendevent(["platform", "event", "friend_score", lifetime])
        appglobal.debugMsg("Friend "+fantainid+" Lifetime Score Updated: " + lifetime, appglobal.debugLevel.msgs);
        appglobal.debugMsg("Friend "+fantainid+" match Score Updated: " + match, appglobal.debugLevel.msgs);
        appglobal.fVM.updateFriendScore(fantainid, lifetime, match);
    }

    namespace.added_as_a_friend = function(fantainid_addedyou) {
        fantain.analytics.sendevent(["platform", "response", "add_friend", fantainid_addedyou])
        appglobal.debugMsg("You were added as a friend by : " + fantainid_addedyou, appglobal.debugLevel.msgs);
    }

    namespace.removed_as_a_friend = function(fantainid_removedyou) {
        fantain.analytics.sendevent(["platform", "response", "remove_friend", fantainid_removedyou])
        appglobal.debugMsg("You were removed as a friend by : " + fantainid_removedyou, appglobal.debugLevel.msgs);
    }
    //Generic error handler when something goes wrong on the server side...    
    namespace.handle_error = function(errmsg) {
        fantain.analytics.sendevent(["platform", "event", "error", null])
        appglobal.debugMsg("Error occurred" + errmsg, appglobal.debugLevel.msgs);
    }

    //News events
    namespace.news_update = function(newsitem)  {
        fantain.analytics.sendevent(["platform", "event", "news", null])
        appglobal.debugMsg("News item received : " + newsitem, appglobal.debugLevel.msgs);
        //alert("News item received : " + newsitem);
        appglobal.fVM.updateTicker (newsitem);
        //appglobal.fVM.matchTicker(newsitem);appglobal.fVM.matchTickerAnimate(!appglobal.fVM.matchTickerAnimate());
    }

    namespace.match_closed = function(matchid) {
        fantain.analytics.sendevent(["platform", "event", "match_closed", null])
        appglobal.debugMsg("Match closed : " + matchid, appglobal.debugLevel.msgs);
        appglobal.fVM.matchClosed(matchid);
    }

})(fantain.fq.api, fg, fantain.analytics, jQuery);
