(function (namespace, Undefined) {

//All our quizzes
    namespace.quiz = [];

    namespace.RESPTYPES = {
    OPEN      : { value : 'o', desc : 'Open'   },
    CLOSED    : { value : 'c', desc : 'Closed' } ,
    CANCELLED : { value : 'x', desc : 'Cancelled' } ,
    };

    namespace.Choice = function() {
    //This is the Choice datastructure here are the key elements
    // respid  : ID of the choice
    //resptext : The actual text of the choice
    //responses : the count of total fans who picked this choice as response.
//        return this;
    };

    namespace.Choice.prototype.toJSON = function () {
        var aresp = {};
        aresp.id = this.choiceid;
        aresp.txt = this.choicetext;
        return aresp;
    };

    namespace.Choice.Create = function (data) {
        var myobj = new namespace.Choice();
    
        myobj.choiceid = data.id;
        myobj.choicetext = data.txt;
        myobj.responses = (data.p != Undefined)?data.p : 0;
        return myobj;
    };

    namespace.Choice.UpdateStats = function(aquiz, chid, responses) {
            for (var i=0;i< aquiz.choices.length;i++) {
                if (aquiz.choices[i].choiceid == chid) {
                    aquiz.choices[i].responses = responses;
                }
            }

    };

    namespace.UserQuiz =  function(){
    //This is the UserQuiz datastructure.  Here is the key datastructure elements
    // quizid : ID of the quiz
    // quiztext : The question
    // choices : Collection of Choice objects
    // qstatus : Current status - can be one of the choice types Open / Responded / Closed / Cancelled
    //correctanswer : This field is set only if the status type is closed
    //myanswer : this field is set only if the status type is responded
    
    };

    namespace.UserQuiz.prototype.toJSON = function() {
        var data = {};
        data.q.id = this.quizid;
        data.q.txt = this.quiztext;
        data.r = this.choices;
    
        data.s.st = this.qstatus.value;
        switch(this.qstatus) {
        case  namespace.RESPTYPES.CLOSED :
            data.s.cid = this.qstatus.correctanswer;
            break;

        } 

        return data;
    };

    namespace.UserQuiz.Create = function(data) {
        var myobj = new namespace.UserQuiz();
        myobj.quizid      = data.q.id;
        myobj.quiztext    = data.q.txt;
        myobj.createdon = data.t;
        myobj.responses = (data.p != Undefined)?data.p:0;

        myobj.choices = [];
        var resp = null; 
        for (var i=0;i< data.r.length;i++) {
            var aresp = namespace.Choice.Create(data.r[i]);
            myobj.choices.push(aresp);
        }
 
        if (data.s.mid != Undefined) 
            myobj.myanswer = data.s.mid;
        switch(data.s.st) {
        case  namespace.RESPTYPES.OPEN.value:
            myobj.qstatus = namespace.RESPTYPES.OPEN;
            break;

        case namespace.RESPTYPES.CLOSED.value :
            myobj.qstatus = namespace.RESPTYPES.CLOSED;
            myobj.correctanswer = data.s.cid;
            myobj.score = data.s.scr;
            break;

        case namespace.RESPTYPES.CANCELLED.value :
            myobj.qstatus = namespace.RESPTYPES.CANCELLED;
            break;
        } 
        myobj.choices.sort( function(l, r) { return parseInt(l.choiceid) - parseInt(r.choiceid); });
        return myobj;
    }
    
    namespace.UserQuiz.Update = function(data) {
    myobj = null;
        for (var i=0;i<namespace.quiz.length;i++) {
            if ( namespace.quiz[i].quizid == data.q.id) {
                myobj = namespace.quiz[i];
                break;
            }
        }
        if (myobj != null) {
            namespace.quiz[i].quiztext = data.q.txt;
            if (data.s.mid != Undefined)
                namespace.quiz[i].myanswer = data.s.mid;

            namespace.quiz[i].choices = [];
            var resp = null; 
            for (var j=0;j< data.r.length;j++) {
                var aresp = namespace.Choice.Create(data.r[j]);
                namespace.quiz[i].choices.push(aresp);

            switch(data.s.st) {

                case 'c' :
                namespace.quiz[i].qstatus = namespace.RESPTYPES.CLOSED;
                namespace.quiz[i].correctanswer = data.s.cid;
                namespace.quiz[i].score = data.s.scr;
                break;

                case 'x' :
                namespace.quiz[i].qstatus = namespace.RESPTYPES.CANCELLED;
                break;

                case 'o' :
                namespace.quiz[i].qstatus = namespace.RESPTYPES.OPEN;
                break;

                } 
            }
            namespace.quiz[i].choices.sort( function(l,r) { return parseInt(l.choiceid) - parseInt(r.choiceid); });
            namespace.quiz.sort(function (r, l) { return parseInt(r.quizid) - parseInt(l.quizid); });
        }
        else
        {
            //If this happens we have got a new quiz let us treat 
            //it as one
            var quizobj = namespace.UserQuiz.Create(data);
            fantain.fq.quiz.push(quizobj);
        }
        
        for (var i=0;i<namespace.quiz.length;i++) 
            if ( namespace.quiz[i].quizid == data.q.id) 
                return i;
    }
    
    namespace.UserQuiz.UpdateAnswer = function(quizid, respid) {
        for (var i=0;i<namespace.quiz.length;i++) {
            if ( namespace.quiz[i].quizid == quizid) {
                namespace.quiz[i].myanswer = respid;
                return i;
            }
        }
    }

    namespace.UserQuiz.UpdateScore = function(quizid, score) {
        for (var i=0;i<namespace.quiz.length;i++) {
            if ( namespace.quiz[i].quizid == quizid) {
                namespace.quiz[i].score = score;
                return i;
            }
        }
    }

    namespace.UserQuiz.UpdateStats = function(data) {
        for (var i = 0; i < namespace.quiz.length; i++) {
            if (namespace.quiz[i].quizid == data.q.id) {
                namespace.quiz[i].responses = data.q.p;
                for (var j = 0; j < data.ch.length; j++) {
                    namespace.Choice.UpdateStats(
                        namespace.quiz[i],
                        data.ch[j].id,
                        data.ch[j].p);
                }
                return i;
            }
        }
    }
})(fantain.fq);
